#!/usr/bin/perl -W
# use strict;

  our $beamline         = '23d';                        # biocat=18ID, gmca=23i, 23o, 23b
  our $undulator        = '';                           # biocat=ID18, gmca=ID23ds,...(?)
# our $shutter          = $beamline.':SH:mp:bo';        # shutter control
# our $shutter_readback = $beamline.':SH:mp:bo:rbk';    # shutter readdback
  our $shutter          = $beamline.':bo0:ch6';         # shutter control
  our $shutter_readback = $beamline.':bo0:ch6';         # shutter readdback
  our $shutter_open     = 1;                            # Digital I/O status for shutter open
  our $shutter_closed   = 1 - $shutter_open;		# Digital I/O status for shutter closed
  our $FEshutter        = 'FE:23:ID:FEshutter';         # biocat=FE:18:ID:FEshutter, gmca=FE:23:ID:FEshutter
# our $HUTCHshutterSTS  = $beamline.':MBSHI:status';	# endstation shutter status PV: 0=open, 1=closed
# our $HUTCHshutterOPE  = $beamline.':V2000:6';		# endstation shutter open PV
# our $HUTCHshutterCLO  = $beamline.':V2000:7';		# endstation shutter close PV   our $struckName       = 's1';                         # struck name (mcs=BioCAT, s1=GMCA)
  our $HUTCHshutterSTS  = $shutter_readback;		# endstation shutter status PV: 0=open, 1=closed
  our $HUTCHshutterOPE  = $shutter;			# endstation shutter open PV
  our $HUTCHshutterCLO  = $shutter;			# endstation shutter close PV   our $struckName       = 's1';                         # struck name (mcs=BioCAT, s1=GMCA)
  our $struckName       = $beamline.':s1';              # struck name (mcs=BioCAT, s1=GMCA)
  our $struck_ext       = ':mca';                       # struck extension for individual channesl (""=BioCAT, ":mca"=GMCA)
  our $struckChName     = $struckName.$struck_ext;	# struck name (mcs=BioCAT, s1:mca=GMCA)
  our $scanrecName      = $beamline.':1:scan1';         # scanrec name (scan1=BioCAT, 1:scan1=GMCA)
  our $scanrecAbort     = $beamline.':1:AbortScans';    # scanrec abort PV (AbortScans=BioCAT, 1:AbortScans=GMCA)
  our $scanrecPause     = $beamline.':1:scanPause';     # scanrec pause PV (scanPause=BioCAT, 1:scanPause=GMCA)
  our $joergerName      = $beamline.':scaler';          # Joerger scaler name (scaler=BioCAT & GMCA)
# our $bluiceLogPV      = $beamline.':FPE:cmd_input';	# where to write log_note, log_warn and log_error
  our $bluiceLogPV      = $beamline.':FPE:cmd_output256';# where to write log_note, log_warn and log_error
  our $robot            = $beamline.':R:';              # sample mounting robot prefix
  our $attenuatorPV     = $beamline.':bo0:ch';		# intensity attenuators channel number prefix in the PV
  our $attenuatrbPV     = $beamline.':rb0:ch';		# intensity attenuators channel number readback prefix in the PV
  our $nAttenuators     = 16;		                # number of intensity attenuators
  our $Attenuators_IN   = 0;				# Digital I/O state of intensity attenuators when IN
# our $axisCameraURL    = '164.54.103.11';		# Axis Video Server URL (sample; actually PZT camera)
# our $axisCameraURL2   = '164.54.103.11';		# Axis Video Camera URL (hutch)
  our $axisCameraURL    = '164.54.103.221';		# Axis Video Server URL (sample)
  our $axisCameraURL2   = '164.54.103.222';		# Axis Video Camera (hutch)
  our $mysqlHost        = 'px3';			# MySQL host for this beamline
  our $mysqlUser        = 'dhs';			# MySQL user (BluIce)
  our $mysqlPass        = '';				# MySQL pass (BluIce)
  our $mysqlDb          = 'blc2004';			# MySQL DB (BluIce)
  our $PLATFORM_IS_64BIT = 1;
  our $CAQTDM           = 1;				# use caqtdm instead of medm
  our $USE_FALCON       = 0;                            # 0=Canberra, 1=Falcon

  if (defined &setEpicsRetry) {&setEpicsRetry();}       # retry no more than 20 times
  if (defined &setEZCA32or64) {&setEZCA32or64();}
