#!/usr/bin/perl -w
#--------------------------------------------------------------
# This script sends email to SMS when beam is back
#
#                   Author: Sergey Stepanov
#
# For more fancy approach check http://wiki.cdyne.com/
#
#  Version-1.0: 2010/12/02
#  Version-1.1: 2010/12/08 Disclaimer added.
#--------------------------------------------------------------
  use strict;
  use Tk;
  use Tk::LabFrame;
  use Tk::BrowseEntry;
  use MIME::Lite;
  use Pezca;

  my ($PEZCA, $script, $mw, @carriers, @emails, $fgn, $fga);
  my ($buttonGo, $buttonCancel, $buttonDisclaim);
  my ($entry_number, $dropdown_menu, $dropdown_value, $frame1, $frame2);

  if    (defined $ENV{PEZCA})     {$PEZCA=$ENV{PEZCA};}
  elsif (defined $ENV{FASTSCANS}) {$PEZCA=$ENV{FASTSCANS}; $PEZCA=~s/fastscans$/pezca/i;}
  else {if ($^O !~ /Win/i) {$PEZCA='/home/gmca/epics/pezca';}else{$PEZCA='c:/gmca/pezca';}}
  $PEZCA =~ s/\\/\//g;

  do $PEZCA.'/Common/common_subs.pl';

  select STDOUT; $|=1;					#set unbuffered output
  $script = &makeScriptName();

  $SIG{'HUP'}  = 'signal_handler';			#(1) hangup (see signum.h)
  $SIG{'INT'}  = 'signal_handler';			#(2) interrupt (see signum.h)
  $SIG{'QUIT'} = 'signal_handler';			#(3) quit (see signum.h)
# $SIG{'KILL'} = 'signal_handler';			#(9) this is what is sent by kill -9 -- unblockable
  $SIG{'TERM'} = 'signal_handler';			#(15) terminate -- sent by kill without paramaters
# $SIG{'STOP'} = 'signal_handler';			#(19) stop -- unblockable

### Per: http://sms411.net/how-to-send-email-to-a-phone/
  @carriers = (''
              ,'Alltel'
              ,'AT&T'
              ,'Bell Canada'
              ,'Boost Mobile'
              ,'Cellular South'
	      ,'Centennial Wireless'
              ,'Cincinnati Bell'
              ,'Cricket Wireless'
	      ,'Metro PCS'
              ,'Nextel'
              ,'Qwest'
              ,'Rogers'
	      ,'Sprint'
              ,'Suncom'
              ,'T-Mobile'
              ,'Telus'
              ,'Verizon'
              ,'Virgin Mobile USA'
              ,'U.S. Cellular'
              );
  @emails = (''
              ,'@message.alltel.com'		#'Alltel'
              ,'@txt.att.net'			#'AT&T'
              ,'@txt.bellmobility.ca'		#'Bell Canada'
              ,'@myboostmobile.com'		#'Boost Mobile'
              ,'@csouth1.com'			#'Cellular South'
	      ,'@cwemail.com'			#'Centennial Wireless'
              ,'@gocbw.com'			#'Cincinnati Bell'
              ,'@sms.mycricket.com'		#'Cricket Wireless'
	      ,'@metropcs.sms.us '		#'Metro PCS'
              ,'@messaging.nextel.com'		#'Nextel'
              ,'@qwestmp.com'			#'Qwest'
              ,'@pcs.rogers.com'		#'Rogers'
	      ,'@messaging.sprintpcs.com'	#'Sprint'
              ,'@tms.suncom.com'		#'Suncom'
              ,'@tmomail.net'			#'T-Mobile'
              ,'@msg.telus.com'			#'Telus'
              ,'@vtext.com'			#'Verizon'
              ,'@vmobl.com'			#'Virgin Mobile USA'
              ,'@email.uscc.net'		#'U.S. Cellular'
              );

  $mw = MainWindow->new(-title => 'Notify me when beam is back via SMS!');
# $mw->geometry("320x150+100+120");
  $frame1 = $mw->Frame->pack;
  $frame2 = $mw->Frame->pack;


  &drawUser($frame1);
  $buttonGo       = $frame2->Button(-text=>'Go!',        -padx=>5,-pady=>5,-command =>\&go_action, )->grid(-column=>0,-row=>0,-padx=>5);
  $buttonCancel   = $frame2->Button(-text=>'Cancel',     -padx=>5,-pady=>5,-command =>\&bye_action,)->grid(-column=>1,-row=>0,-padx=>5);
  $buttonDisclaim = $frame2->Button(-text=>'Disclaimer', -padx=>5,-pady=>5,-command =>\&disclaimer_action,)->grid(-column=>2,-row=>0,-padx=>5);

  $fgn = '#bbbbdd';
  $fga = '#bbbbff';
  $buttonGo      ->configure(-background=>$fgn,-activebackground=>$fga);
  $buttonCancel  ->configure(-background=>$fgn,-activebackground=>$fga);
  $buttonDisclaim->configure(-background=>$fgn,-activebackground=>$fga);

  MainLoop;

#==========================================================================

sub drawUser($) {
  my ($mother, $label_number, $carrier);

  $mother = shift;

# $label_number  = $mother->Label(-text=>'Cell phone:',-padx=>5,-pady=>5,)->pack(-side=>'left');
# $entry_number  = $mother->Entry(-width=>12,-validate=>'key',-validatecommand=>sub{$_[1] =~/[0-9]/},-invalidcommand=>sub{$mother->bell},)->pack(-side=>'left');
# $label_carrier = $mother->Label(-text=>'Carrier:',-padx=>5,-pady=>5,)->pack(-side=>'left');
# $label_carrier = $mother->Label(-text=>'Carrier:',-padx=>0,-pady=>5,)->grid(-column=>2,-row=>0,-padx=>10);
# $button        = $mother->Button(-text=>'Exit', -padx=>5,-pady=>5,-command =>\&bye_action,)->pack(-side=>'right');

  $label_number  = $mother->Label(-text=>'Cell phone (e.g. 1234567890):',-padx=>0,-pady=>5,)->grid(-column=>0,-row=>0,-padx=>5);
  $entry_number  = $mother->Entry(-width=>11,-validate=>'key',-validatecommand=>sub{$_[1] =~/[0-9]/},-invalidcommand=>sub{$mother->bell},-exportselection=>1,)->grid(-column=>1,-row=>0,-padx=>5);
  $dropdown_menu = $mother->BrowseEntry(-label=>'Carrier: ',-variable =>\$dropdown_value,-choices=>\@carriers,-state=>'readonly',-disabledbackground=>'white',-disabledforeground=>'black',)->grid(-column=>2,-row=>0,-padx=>10);
# foreach $carrier (@carriers) {$dropdown_menu->insert('end', $carrier);}
### Set the initial value for the dropdown
  $dropdown_value = $carriers[0];
  $entry_number->focusForce;

}

#==========================================================================
sub go_action() {

  my ($cell, $i, $carrier, $email, $pv, $permit, $step, $status);
  my ($from, $subject, $to, $body, $stamp, $msg, $fh);

  $cell = $entry_number->get();
  if (length($cell) != 10) {
     $mw -> messageBox(-title=>'Incorrect number!',
                       -message=>'Cell phone number must contain 10 digits without spaces',
                       -wrap=>0,
                       -type=>'ok',
                       -icon=>'error');
     return;
  }
  if (length($dropdown_value) < 1) {
     $mw -> messageBox(-title=>'Incorrect carrier!',
                       -message=>'Please choose cell phone carrier!',
                       -wrap=>0,
                       -type=>'ok',
                       -icon=>'error');
     return;
  }
  $i = 0;
  foreach $carrier (@carriers) {
    if ($dropdown_value eq $carrier) {last;}
    $i++;
  }
  $email = $cell.$emails[$i];
  $mw->withdraw();				#hide main window
  $mw -> messageBox(-title=>'E-mail',
                    -message=>'When beam comes back, e-mail will be sent to '.$email,
                    -wrap=>0,
                    -type=>'ok',
                    -icon=>'info');
  $pv = 'ACIS:ShutterPermit';
  $status = &addCaMonitor($pv);
  &report_only($script,$status,$pv);
  $permit = 0;
  $step   = 10;					#in seconds
  do {
     sleep($step);
     ($status,$permit) = Pezca::GetDouble($pv);
     if ($status) {
        &report_only($script,$status,$pv);
	$permit = 0;
     }
     if (!defined $permit) {$permit=0;}
  } while ($permit == 0);

  $from     = 'noreply@gmca.anl.gov';
  $subject  = 'APS beam is back';
  $to       = $email;
# $to       = 'sstepanov@anl.gov';
  $stamp    = scalar localtime;
  $body     = 'APS beam is back at '.$stamp;

  $msg = MIME::Lite->new(Subject=>$subject,From=>$from,To=>$to,
                         Cc=>'sstepanov@anl.gov',
                         Type=>'text/plain',
                         Encoding=>'quoted-printable',
                         Data=>$body);
  $msg->add('Reply-To'=>$from);
  if ($^O =~ /Win/i) {MIME::Lite->send('smtp', 'px1.gmca.aps.anl.gov', Timeout=>60);}
  $msg->send;

  $mw -> messageBox(-title=>'E-mail sent',
                    -message=>'Beam is back, e-mail is sent to '.$email,
                    -wrap=>0,
                    -type=>'ok',
                    -icon=>'info');
  &clearAllCaMonitors();
  exit;
}

#==========================================================================
sub disclaimer_action() {

  my ($cell, $i, $carrier, $email, $txt);

  $cell = $entry_number->get();
  $email = '';
  if (length($dropdown_value) >= 1) {
     $i = 0;
     foreach $carrier (@carriers) {
       if ($dropdown_value eq $carrier) {last;}
       $i++;
     }
     $email = $cell.$emails[$i];
  }
  if    (length($cell) == 10 && length($email) > 0) {$txt = $cell.$email;}
  elsif (length($cell) == 10) {$txt = $cell.'@<your.carrier.cell.address>';}
  elsif (length($email) > 0)  {$txt = '<yourcellphonenumber>'.$email;}
  else  {$txt = 'E-mail address of your cell phone';}

  $txt = 'Disclaimer: the message will be sent to '.$txt.".\n"
	.'Timely delivery is the responsibility of your cell phone provider.';

  $mw -> messageBox(-title=>'Disclaimer',
                    -message=>$txt,
                    -wrap=>0,
                    -type=>'ok',
                    -icon=>'info');
}

#==========================================================================
sub bye_action() {
  print STDOUT "\n".'Goodbye!'."\n\n";
  exit;
}

#=================================================================

sub signal_handler {
  my $signame = shift;
# local($signame) = @_;
  print STDOUT "\n".$script.': *** Caught a SIG'.$signame."\n";
  &clearAllCaMonitors();
  print STDOUT $script.': exiting!'."\n\n";
  exit 1;
}
