#!/usr/bin/perl -W
#--------------------------------------------------------------
# This script checks /etc/hosts for records not listed in DNS
#
#         	Author: Sergey Stepanov
#
# Version-1.0: 2016/06/08 initial implementation
#--------------------------------------------------------------
  use strict;

  my ($script, $hosts, $key, $filehandle, $str, @words, $nwords);
  my ($ip, $hostname, @rsp, $dns);

  select STDOUT; $|=1;					#set unbuffered output
  select STDERR; $|=1;					#set unbuffered output

  $script = $0;
  $script =~ s/\\/\//g		;			#change \ to /
  $script =~ s/^.*\///g;				#remove everything before last /
  $script =~ s/\.pl$//i;

#---------------------------------------------------------------------
  if ($^O =~ /Win/i) {die $script.': cannot run under Windows.'."\n";}
#---------------------------------------------------------------------

  $hosts = '/etc/hosts';
  $key   = '164.54.103';

  $filehandle = open (HOSTS, '< '.$hosts);
  if (!defined $filehandle) {die $script.': cannot open "'.$hosts.'" for reading.'."\n";}

  while ( <HOSTS> ) {
     $str = $_;
     chomp $str;		# trail CR
     $str =~ s/^\s+//g;		# remove beginning-of-the-line spaces
     if ($str !~ /^$key/) {next;}
     @words = split(/\s+/,$str);
     $nwords = @words;
     if ($nwords < 2) {next;}
     $ip       = $words[0];
     $hostname = $words[1];
#    $str = 'host '.$hostname;
     $str = 'host '.$ip;
#    print STDOUT $str."\n";
     $str = `$str`;  
     if ($str =~ /not found:/) {
        printf STDOUT 'Host=%-40s IP=%-16s is not in DNS'."\n",$hostname,$ip;
     } else {
        @rsp = split(/\s+/,$str);
        $dns = $rsp[-1];
        chomp $dns;
        $dns =~ s/\.$//;
        if ($dns ne $hostname) {
           printf STDOUT 'DNS=%-40s and HOSTS=%-40s for IP=%-16s are different'."\n",$dns,$hostname,$ip;
        }
     }
  }
  close(HOSTS);
  exit;
