#!/usr/bin/perl -W
#----------------------------------------------------
# Find the name of the main network interface
#----------------------------------------------------
  use strict;
  my (@inets, $inet, $str);
  my ($LS, $IFCONFIG, $GREP);

  if    (-e '/bin/ls')            {$LS = '/bin/ls';}
  elsif (-e '/usr/bin/ls')        {$LS = '/usr/bin/ls';}
  elsif (-e `which ls`)           {$LS = `which ls`;}
  else                            {die 'ls command not found';}

  if    (-e '/sbin/ifconfig')     {$IFCONFIG = '/sbin/ifconfig';}
  elsif (-e '/usr/sbin/ifconfig') {$IFCONFIG = '/usr/sbin/ifconfig';}
  elsif (-e `which ifconfig`)     {$IFCONFIG = `which ifconfig`;}
  else                            {die 'ifconfig command not found';}

  if    (-e '/bin/grep')          {$GREP = '/bin/grep';}
  elsif (-e '/usr/bin/grep')      {$GREP = '/usr/bin/grep';}
  elsif (-e `which grep`)         {$GREP = `which grep`;}
  else                            {die 'grep command not found';}

  @inets = split(/\n/, `$LS -1 /sys/class/net`);

  foreach $inet (@inets) {
    $str = `$IFCONFIG $inet | $GREP 164.54.103.`;
    if (length($str) > 0) {print STDOUT $inet,"\n"; exit;}
  }

