#!/usr/bin/perl -W
#--------------------------------------------------------------
# This PERL script makes a tar copy of BluIce for the www.gmca.aps.anl.gov
# It is supposed to be called by cron on Linux.(see /etc/crontab)
#
#                    Author: Sergey Stepanov
#--------------------------------------------------------------
# use Cwd;
  use strict;
  my ($script, $sitedir, $sitefile, $sitefilefull, $host, $user, $home);
  my ($wwwhost, $wwwdestination, $beamlinedir, @cmd, $status, $str);
  my (@ct, $mday, $month, $year, $stamp, $lastfile, $buff1, $buff2);

# $script         = 'sitefilecopy.pl';
  $script         = $0;
  $script         =~ s/^.*\///g;			#remove everything before last "/"
  $wwwhost        = 'gmca@www.gmca.aps.anl.gov';
  $wwwdestination = '/home/sergey/WWW/sitefiles/';
  
  select STDERR; $|=1;
  select STDOUT; $|=1;

  if ($^O =~ /Win/i) {die $script.': cannot run on Windows'."\n";}

  if (defined $ENV{USER}) {$user = $ENV{USER};} 
  else                    {$user = 'unknown';}
  if (defined $ENV{HOME}) {$home = $ENV{HOME};} 
  else                    {$home = 'unknown';}
  
  if ($home =~ /^\/root\/?/)                 {$user = 'root';}
  if (defined $ENV{EUID} && $ENV{EUID} == 0) {$user = 'root';}

  if (defined $ENV{HOSTNAME}) {$host = $ENV{HOSTNAME};}
  if (!defined $host) {$host=`/bin/hostname -s`; $host=~s/\n//g;}
  &sendmail('HOSTNAME is undefined!') unless defined $host;
  $host = lc($host);
  $host =~ s/\.gmca\.aps\.anl\.gov$//;
  print STDOUT "\n".'Starting '.$script.' for user='.$user.' on host='.$host."\n";

  $sitefile = 'def.site';

  if    ($host =~ /^bl1/) {
     $beamlinedir = 'id-in';
#    $sitedir     = '/mnt/software/px/hklint/IDD_MAR300';
     $sitedir     = '/mnt/software/px/hklint/IDD_Pilatus3_6M';
  }
  elsif ($host =~ /^bl2/) {
     $beamlinedir = 'id-out';
#    $sitedir     = '/mnt/software/px/hklint/IDB_MAR300';
     $sitedir     = '/mnt/software/px/hklint/IDB_EIGER16M';
  }
  elsif ($host =~ /^bl3/) {
     $beamlinedir = 'bm';
#    $sitedir     = '/mnt/software/px/hklint/BM_MAR225';
     $sitedir     = '/mnt/software/px/hklint/IDD_MAR300';
  }
  else {&sendmail('Cannot attribute host='.$host.' to a beamline!');}

  print STDOUT $script.': site files directory='.$sitedir."\n";

  $sitefilefull .= $sitedir.'/'.$sitefile;
  if (! -f $sitefilefull)    {&sendmail('site file "'.$sitefilefull.'" does not exist!');}

  $wwwdestination .= $beamlinedir.'/';					#append directory
  print STDOUT $script.': WWW destination dir.='.$wwwdestination."\n";

###------------------------------------------------------------------------------
### Check if ssh connection to $wwwhost is OK:
  print STDOUT "\n".$script.': checking connection to '.$wwwhost."\n";
  @cmd = ('/usr/bin/ssh','-q','-o','BatchMode=yes','-o','StrictHostKeyChecking=no',$wwwhost,'"/bin/date"','>/dev/null');
  print STDOUT "\n".$script.":\n@cmd\n";
  $status = system(@cmd);
  if ($status > 1)  {
     &sendmail('"'."@cmd".'"'."\n\n"
              .'failed for user='.$user.' with status='.$status."\n"
              .'Make sure that RSA public key of user='.$user.' on '.$host.' is'."\n"
              .'installed at '.$wwwhost.', that is it is readable'."\n"
              .'by user only and that the home directory is writable by user only.');
  }
  else {print STDOUT "\n".$script.': connection is OK.'."\n\n";}

###------------------------------------------------------------------------------
### Find the latest site file on WWW:
  print STDOUT $script.': finding the latest site file on WWW:'."\n";
# $str = '/usr/bin/ssh -q -o BatchMode=yes '.$wwwhost.' "/bin/ls -t '.$wwwdestination.$sitefile.'_* | /usr/bin/head -1"';
  $str = '/usr/bin/ssh -q -o BatchMode=yes '.$wwwhost.' "/bin/ls -1 '.$wwwdestination.$sitefile.'_* | /usr/bin/tail -1"';
  print STDOUT $str."\n";
  $lastfile = `$str`;
  chomp $lastfile;
  print STDOUT $script.': the latest '.$sitefile.' file on WWW is "'.$lastfile.'".'."\n";

###------------------------------------------------------------------------------
### Compare the current site file and the last site file on WWW:
  print STDOUT "\n".$script.': comparing current site file and the latest site file on WWW:'."\n";
  $str = '/bin/cat '.$sitefilefull;  
  print STDOUT 'buff1=['.$str.']'."\n";
  $buff1 = `$str`;
  $str = '/usr/bin/ssh -q -o BatchMode=yes '.$wwwhost.' "/bin/cat '.$lastfile.'"';  
  print STDOUT 'buff2=['.$str.']'."\n";
  $buff2 = `$str`;
  print STDOUT "\n"
              .'Content of '.$sitefile.' :'."\n".$buff1."\n"
              .'Content of '.$lastfile.' :'."\n".$buff2."\n";
  if ($buff1 eq $buff2) {
     print STDOUT $script.': current site file and the latest site file on WWW are the same.'."\n\n".'Exiting.'."\n\n";
     exit;
  } else {
     print STDOUT $script.': current site file and the latest site file on WWW are different. Continuing...'."\n\n";
  }

###------------------------------------------------------------------------------
### Check if destination file exits; in case it does, checking if it can be overwritten:
  @ct	   = localtime(time);
  $mday    = $ct[3];
  $month   = $ct[4]+1;
  $year    = $ct[5]+1900;
  $stamp   = sprintf '_%04d_%02d_%02d', $year,$month,$mday;
  $wwwdestination .= $sitefile.$stamp;				#append new file name
  print STDOUT "\n".$script.': WWW destination file='.$wwwdestination."\n";

  print STDOUT "\n".$script.': checking if destination file '.$wwwhost.':'.$wwwdestination.' exists.'."\n";
  @cmd = ('/usr/bin/ssh','-q','-o','BatchMode=yes',$wwwhost,'/usr/bin/test','-f',$wwwdestination);
  print STDOUT "\n".$script.":\n@cmd\n\n";
  $status = system(@cmd);
  if ($status == 0) {						#file exists
     print STDOUT "\n".$script.': Found that file '.$wwwhost.':'.$wwwdestination.' exists!'."\n\n";

### Check if destination file is writable:
     print STDOUT "\n".$script.': checking if destination file '.$wwwhost.':'.$wwwdestination.' is writable.'."\n";
#    @cmd = ('/usr/bin/ssh','-q','-o','BatchMode=yes',$wwwhost,'/usr/bin/test','-w',$wwwdestination,'>/dev/null');
     @cmd = ('/usr/bin/ssh','-q','-o','BatchMode=yes',$wwwhost,'/usr/bin/rm','-f',$wwwdestination,'>/dev/null');
     print STDOUT "\n".$script.":\n@cmd\n";
     $status = system(@cmd);
     if ($status) {&sendmail('File "'.$wwwhost.':'.$wwwdestination.'" exists and is not overwritable!');}
     else {
       print STDOUT "\n".$script.': file '.$wwwhost.':'.$wwwdestination.' is OK to overwrite.'."\n\n";
     }
  } 
  else {print STDOUT "\n".$script.': file '.$wwwhost.':'.$wwwdestination.' does not exist.'."\n\n";}
  
###------------------------------------------------------------------------------
### Copying sitefile to the WWW server:
  print STDOUT "\n".$script.': copying site file to '.$wwwhost.':'.$wwwdestination."\n";
  @cmd = ('/usr/bin/scp','-pqB',$sitefilefull,$wwwhost.':'.$wwwdestination);
  print STDOUT "\n".$script.":\n@cmd\n";
  $status = system(@cmd);
  if ($status) {&sendmail('"'."@cmd".'" failed with status='.$status);}
  else {print STDOUT "\n".$script.': site file copied OK.'."\n\n";}

###------------------------------------------------------------------------------
### Changing sitefile permissions on the WWW server:
  print STDOUT "\n".$script.': making site file '.$wwwhost.':'.$wwwdestination.' read-only.'."\n";
  @cmd = ('/usr/bin/ssh','-q','-o','BatchMode=yes',$wwwhost,'/bin/chmod','a-wx',$wwwdestination,'>/dev/null');
  print STDOUT "\n".$script.":\n@cmd\n";
  $status = system(@cmd);
  if ($status) {&sendmail('"'."@cmd".'" failed with status='.$status);}
  else {print STDOUT "\n".$script.': site file permissions are changed to read-only OK.'."\n\n";}

  print STDOUT "\n".$script.': All done.'."\n\n";
  exit;

###----------------------------------------------------------------------------------
###----------------------------------------------------------------------------------

  sub sendmail ($) {
  my ($txt, $from, $to, $reply_to, $subject, $stamp, $sendmail, $handle);
  $txt = shift (@_);
  $from = 'sstepanov@anl.gov';
  $to = $from;
  $reply_to = 'sstepanov@anl.gov';
  $subject = $script.' failed on '.$host;
  $stamp    = scalar localtime;
  $sendmail = '/usr/sbin/sendmail -t';
  $handle = open (SENDMAIL, '| '.$sendmail);
  if (defined $handle) {
     print SENDMAIL 'From: '.$from."\n";
     print SENDMAIL 'Reply-to: '.$reply_to."\n";
     print SENDMAIL 'Subject: '.$subject."\n";
     print SENDMAIL 'To: '.$to."\n";
     print SENDMAIL 'Content-type: text/plain'."\n\n";
     print SENDMAIL 'Date: '.$stamp."\n\n";
     print SENDMAIL 'ERROR:'."\n".$txt."\n\n";
  } else {
     print STDERR '*** '.$script.': failed to open pipe to '.$sendmail."\n";
  }
  print STDERR '*** '.$script.' ERROR:'."\n".$txt."\n\n";
  exit;
}
