#!/usr/bin/perl -W
#--------------------------------------------------------------
#
# This script calculates sum(1/(focus*$delta) for all possible combinations
# of transfocator lenses, i.e. for 2^n states (for n=21, 2^21=2,097,152 and
# for n=19, 2^19=524,288). Then it records it in mySQL (the previous table is
# overwritten).
#
#                       Author: Sergey Stepanov
#
# Version-1.0:  2021/02/05	initial implementation
#--------------------------------------------------------------
# use Pezca;
  use DBI;
  use strict;
  use warnings::unused;

  select STDERR; $|=1;			# set unbuffered output
  select STDOUT; $|=1;			# set unbuffered output

  our ($beamline);
  my ($PEZCA, $script, $status, $msg);

  die 'This script is obsolete: the CRLsum database is deprecated and removed from SQL.'."\n";

  if (!defined $ENV{PEZCA}) {
     die 'Please define the PEZCA environment. It must point to the PERL scripts repository';
  }
  $PEZCA = $ENV{PEZCA};
  $PEZCA =~ s/\\/\//g;
  if ($PEZCA !~ /\/$/) {$PEZCA .='/';}

  if (-e $PEZCA.'Common/common_subs.pl') {
     do $PEZCA.'Common/common_subs.pl';
#    do $PEZCA.'Common/crl_subs.pl';
     do $PEZCA.'Common/OLDER/crl_subs_3.4.pl';
     if (defined $beamline) {do $PEZCA.'/Common/beamline_'.$beamline.'.pl';}
     else                   {do $PEZCA.'/Common/beamline.pl';}
  } else {die '*** Cannot fined PEZCA subs in '.$PEZCA."\n";}
  
  $script = &makeScriptName('noext');

  $status = &fill_CRLsum_sql(\$msg);
  if ($status) {&zenity_error_exit($msg);}
  else         {print STDOUT 'All done, exiting.'."\n";}
  exit;
