#!/usr/bin/perl -W
#---------------------------------------------------------------------------
# Convert Unicode file (UTF-16, UTF-16BE, UTF-16LE, UTF-8....) to ASCII
#
# Designed per:
# http://stackoverflow.com/questions/8142826/how-to-convert-unicode-file-to-ascii-file-in-perl-script-on-windows-machine
#---------------------------------------------------------------------------
  use strict;
  use warnings;

  select STDOUT; $|=1;			# set unbuffered output
  select STDERR; $|=1;			# set unbuffered output

  my ($code, $in, $out, $syntax, $narg, $arg, $i, $buffer, $ifh, $ofh);

  $syntax = 'Usage unicode2ascii [-unicode=UTF-8|UTF-16|UTF-16BE|UTF-16LE/UTF-32] infile outfile'."\n";
  $narg = @ARGV;
  if ($narg < 2) {die 'Insufficient arguments.'."\n".$syntax;}
  for ($i=0; $i<$narg; $i++) {
     $arg = $ARGV[$i];
     if ($arg =~ /^-{0,2}unicode=/) {
	$arg =~ s/^-{0,2}unicode=//;
	if ($arg !~ /^UTF-8/ && $arg !~ /^UTF-16/ && $arg !~ /^UTF-32/) {
           die 'Incorrect UTF='.$arg."\n".$syntax;
        }
	$code = $arg;
	splice @ARGV,$i,1;
	$narg--;
	last;
     }
  }
  if ($narg < 2) {die 'Insufficient arguments.'."\n".$syntax;}
  $in  = $ARGV[0];
  $out = $ARGV[1];
  if (!defined $code) {$code = 'UTF-16';}

  open($ifh, '<:encoding('.$code.')', $in) or die "error: $!\n";
  read($ifh, $buffer, -s $ifh);
  close($ifh);

  open($ofh, '>:encoding(ascii)',    $out) or die "error: $!\n";
  print($ofh $buffer);
  close($ofh);
  exit;
