#!/usr/bin/perl -W
#--------------------------------------------------------------
#              This is a converter from UTF8 to Win-1251
#
#                     Author: Sergey Stepanov
#
# Version-1.0:  2014/01/06
#--------------------------------------------------------------
  use strict;
  use Encode qw(from_to is_utf8);

  my ($narg, $file, @lines, $nlines, $line, $status, $fh);

  $narg = @ARGV;
  if ($narg == 0) {die 'Syntax: utf2ru file';}

  $file = $ARGV[0];
  $status = &read_entire_file ($file,\@lines);
  $nlines = @lines;
  for ($line=0; $line<$nlines; $line++) {&from_to($lines[$line], 'utf8', 'cp1251');}

  $fh = open(DAT, ' > ', $file);
  if (!defined $fh ) {die 'Cannot open file='.$file};
  for ($line=0; $line<$nlines; $line++) {print DAT $lines[$line],"\n";}
  close(DAT);
  exit;

#==========================================================================

# sub read_entire_file($file,\@lines,[$lockflag]) {
sub read_entire_file($\@;$) {

  use Fcntl;

  my ($script, $file, $lockfile, $linesref, $buffer, $status);

  $script   = 'read_entire_file';
  $file     = shift(@_);
  $linesref = shift(@_);
  $lockfile = shift(@_);	if (!defined $lockfile) {$lockfile=0;}

  @$linesref = ();
  $status = sysopen(FH, $file, O_RDONLY);		#O_RDONLY is defined in "use Fcntl";
  if (!defined $status) {print STDERR '*** '.$script.': Could not open '.$file."\n"; return 1;}
  if ($lockfile) {flock(FH, 2);}
  sysread(FH, $buffer, -s FH);
  close FH;
  @$linesref = split(/\r?\n/,$buffer);
  return 0;
}
