package gov.anl.gmca.analysis;

import gov.anl.gmca.analysis.helpers.MiscUtils;
import gov.anl.gmca.gui.Main;
import gov.anl.gmca.syslog.Log;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.browser.ProgressEvent;
import org.eclipse.swt.browser.ProgressListener;

import java.io.IOException;
import java.nio.charset.Charset;

// sort a directory content in the browser
public class SortDirectoryContentInBrowser {
	Browser browser;

	public SortDirectoryContentInBrowser(Browser browser) {
		this.browser = browser;

		String jScriptFile = Main.getAppDir() + "/java/src/gov/anl/gmca/analysis/helpers/" + "sortTable.js";

		String jScript;
		try {
			jScript = MiscUtils.readFile(jScriptFile, Charset.defaultCharset());
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}

		browser.addProgressListener(new ProgressListener() {

			@Override
			public void completed(ProgressEvent arg0) {
				boolean result = browser.execute(jScript);
				// this method has the following problem:
				// if a file is opened in the same window that shows the
				// directory previously, javascript will be run recursively
				// this following line get rids of the recursive behavior
				browser.removeProgressListener(this);

				if (!result) {
					Log.warn("sortTable javascript was not executed.");
					return;
				}
			}

			@Override
			public void changed(ProgressEvent arg0) {}
		});

	}
}
