// javascript to sort a generic table by 1st column
// https://stackoverflow.com/questions/14267781/sorting-html-table-with-javascript
// sortTable(tableNode, columId, false);

function sortTable(table, col, reverse) {
	// use `<tbody>` to ignore `<thead>` and `<tfoot>` rows, put rows into
	// array, skip first row
	var tb = table.tBodies[0], tr = Array.prototype.slice.call(tb.rows, 1), i;
	reverse = -((+reverse) || -1);
	if (tr.length <= 1) {
		return;
	}
	// sort rows using `.textContent.trim()` for test, `-1 *` if want opposite
	// order
	tr = tr.sort(function(a, b) {
		return reverse
				* (a.cells[col].textContent.trim().toUpperCase()
						.localeCompare(b.cells[col].textContent.trim()
								.toUpperCase()));
	});
	// append each row in order
	for (i = 0; i < tr.length; ++i) {
		tb.appendChild(tr[i]);
	}
}

var table = document.getElementsByTagName('Table')[0];
sortTable(table, 0, false);