package gov.anl.gmca.collect.graph;

import gov.anl.gmca.collect.graph.WdgSFGraph.GraphSource;
import gov.anl.gmca.collect.graph.WdgSFGraph.LegendItem;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_RUNS;
import gov.aps.jca.dbr.DBR;

public class DevSFGraph
{
	private static int lastCollectVal=-1, lastSampleVal=-1;
	
	public static void init()
	{
		Epics.addMonitor(PV_RUNS.traceVisCollect, new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, DBR value)
			{
				int val = Epics.dbrToInt(value);
				if (val==lastCollectVal) return;
				update(GraphSource.COLLECT, val);
			}
		});
		update(GraphSource.COLLECT, Epics.getInteger(PV_RUNS.traceVisCollect));
		
		Epics.addMonitor(PV_RUNS.traceVisSample, new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, DBR value)
			{
				int val = Epics.dbrToInt(value);
				if (val==lastSampleVal) return;
				update(GraphSource.SAMPLE, val);
			}
		});
		update(GraphSource.SAMPLE, Epics.getInteger(PV_RUNS.traceVisSample));
	}
	
	private static void update(GraphSource src, int val)
	{
		/*GUI.asyncExec(new Runnable(){public void run()
		{
			for (LegendItem item : LegendItem.values())
			{
				boolean isVisible = (val & 1<<item.ordinal())!=0;
				item.setVisible(src, isVisible, false);
			}
			WdgSFGraph.redrawAll(); // inefficient - should only redraw the affected graph
		}});*/
	}

	public static void setVisible(GraphSource src, int visibility)
	{
		switch (src)
		{
		case COLLECT: Epics.putInteger(PV_RUNS.traceVisCollect, visibility); break;
		case SAMPLE: Epics.putInteger(PV_RUNS.traceVisSample, visibility); break;
		default: throw new IllegalStateException();
		}
	}
}
