package gov.anl.gmca.collect.graph;

import gov.anl.gmca.collect.DevFPE;
import gov.anl.gmca.collect.graph.SFGraph.SpotFinderPoint;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.graphics.Point;

public class SFImageLoad
{
	private SFGraph graph;
	private MouseListener mouseListener;
	private MouseMoveListener mouseMoveListener;
	
	public SFImageLoad(SFGraph graph)
	{
		this.graph = graph;
		
		mouseMoveListener = new MouseMoveListener()
		{
			@Override public void mouseMove(MouseEvent me)
			{
				if (me.stateMask==SWT.BUTTON1) updateImage(me.x,me.y);
			}
		};
		graph.wdg.addMouseMoveListener(mouseMoveListener);
		
		mouseListener = new MouseListener()
		{
			@Override public void mouseDown(MouseEvent me)
			{
				if (me.button==1) updateImage(me.x,me.y);
			}
			@Override public void mouseUp(MouseEvent arg0) {}
			@Override public void mouseDoubleClick(MouseEvent arg0) {}
		};
		graph.wdg.addMouseListener(mouseListener);
	}
	
	private SpotFinderPoint closestPoint;
	private void updateImage(int mouseX, int mouseY)
	{
		Point graphPos = graph.mousePosToGraphPos(mouseX, mouseY);
		SpotFinderPoint prevPoint = closestPoint;
		closestPoint = graph.getClosestPt(graphPos);
		if (closestPoint != prevPoint && null != closestPoint)
		{
			DevFPE.get().setImageViewerFilePath(closestPoint.directory, closestPoint.filename);
		}
	}
}
