package gov.anl.gmca.collect.graph;

import gov.anl.gmca.collect.graph.SFGraph.SpotFinderPoint;
import gov.anl.gmca.collect.graph.WdgSFGraph.LegendItem;
import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;

public class SFPlot
{
	private SFGraph graph;
	public SFPlot(SFGraph graph) { this.graph = graph; }
	
	public void draw(GC gc)
	{
		long startMs = System.currentTimeMillis();

		graph.setPlotTransform(gc);
		
		gc.setBackground(GUI.COLOR_RED);
		gc.setLineWidth(2);
		
		int w=8,h=8,w2=6,h2=6;
		int lasty1=0, lasty2=0, xprev=0;
		boolean connectToLastPoint=false, lastPtWasInverse=false;
		for (int i=graph.points.size()-1; i>=0; i--)
		{
			SpotFinderPoint point = graph.points.get(i);
			
			Color c1 = point.isInverse ? GUI.COLOR_BLUE1 : GUI.COLOR_BLUE2;
			Color c2 = point.isInverse ? GUI.COLOR_GREEN1 : GUI.COLOR_GREEN2;
			
			// TODO: break connections only if points are not in the same partition
			if (lastPtWasInverse != point.isInverse) connectToLastPoint = false;
			
			int x = point.xPlotAreaCoord;
			int y1 = point.yPlotAreaParam1Coord;
			//int y2 = point.yPlotAreaParam2Coord;

			boolean drawOutput1 = LegendItem.LABEL1.isVisible.get(graph.wdg.diffTab.graphSource) && y1 != -1;
			//boolean drawOutput2 = LegendItem.LABEL2.isVisible.get(graph.wdg.diffTab.graphSource);

			//if (drawOutput1) { gc.setBackground(c1); gc.fillOval(x-w/2, y1-h/2, w, h); }
			//if (drawOutput2) { gc.setBackground(c2); gc.fillOval(x-w2/2, y2-h2/2, w2, h2); }

			if (connectToLastPoint)
			{
				if (drawOutput1) { gc.setForeground(c1); gc.drawLine(xprev, lasty1, x, y1); }
				//if (drawOutput2) { gc.setForeground(c2); gc.drawLine(xprev, lasty2, x, y2); }
			}

			xprev=x;lasty1=y1; //lasty2=y2;

			lastPtWasInverse = point.isInverse;
			connectToLastPoint=drawOutput1;
		}

		long elapsedMs = System.currentTimeMillis() - startMs;
		if (elapsedMs > 10) {
			System.out.println("SFPlot draw time "+elapsedMs);
		}
	}
}
