package gov.anl.gmca.collect.ui;

import gov.anl.gmca.collect.ModelCollectRun;
import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

public class WdgCommitButton extends Composite
{
	private ModelCollectRun run;
	private Button commitButton;
	
	public static enum ButtonAction	{ FINISH, RETURN };
	private		ButtonAction		buttonAction;
	
	public WdgCommitButton(Composite parent, ModelCollectRun _run)
	{
		super(parent, SWT.PUSH);
		this.run=_run;
		GridLayout gl = new GridLayout(1,false);
		gl.marginWidth=0;
		gl.marginHeight=0;
		setLayout(gl);
		
		commitButton = new Button(this, SWT.PUSH);
		commitButton.setBackground(GUI.COLOR_LIGHT_GREEN);
		commitButton.setText("Finish Site Setup");
		commitButton.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, false));
		buttonAction = ButtonAction.FINISH;
		commitButton.setToolTipText("Site setup must be completed before continuing to collect parameter setup.");
		commitButton.addSelectionListener(new SelectionListener()
		{
			@Override public void widgetDefaultSelected(SelectionEvent e) {}
			@Override public void widgetSelected(SelectionEvent e)
			{
				run.fii.handleFinishButton(buttonAction);
			}
		});
	}
	
	public void runChanged()
	{
		switch (run.getSetupStep())
		{
		case SITE_SETUP:
			buttonAction = ButtonAction.FINISH;
			commitButton.setBackground(GUI.COLOR_LIGHT_GREEN);
			commitButton.setText("Finish Site Setup");
			commitButton.setToolTipText("Site setup must be completed before continuing to collect parameter setup.");
			getParent().layout(true);
			break;
		case COLLECT_PARAM:
			buttonAction = ButtonAction.RETURN;
			commitButton.setBackground(GUI.COLOR_BLUE_BUTTON);
			commitButton.setText("Return to Site Setup");
			commitButton.setToolTipText("Click here to re-enable site setup.  Collect parameters will be lost.");
			getParent().layout(true);
			break;
		}
	}
	
	@Override public void setEnabled(boolean enabled)
	{
		commitButton.setEnabled(enabled);
	}
}
