package gov.anl.gmca.collect.ui;

import gov.anl.gmca.collect.ui.cam.WdgRasterCamera;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.hutch.GrpWdgMove;
import gov.anl.gmca.hutch.WdgMotor;
import gov.anl.gmca.sample.DBCamera;
import gov.anl.gmca.sample.WdgCamera.CameraSize;
import gov.anl.gmca.sample.WdgCamera.CameraType;
import gov.anl.gmca.sample.WdgSampleRotate;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

public class WdgRasterTab extends Composite
{
	WdgRasterCamera rasterCamera;
	private double rotateNValue = 1.0;
	private WdgSampleRotate rotate;
	
	public WdgRasterTab(Composite parent)
	{
		super(parent, SWT.NONE);
		
		setBackground(GUI.BGCOLOR);
		GridLayout gl = new GridLayout(1,false);
		gl.marginWidth = 0;
		setLayout(gl);

		rasterCamera = new WdgRasterCamera(this, SWT.NONE, DBCamera.getImageURL(CameraType.HIGHRES, CameraSize.LARGE), CameraType.HIGHRES);
		GridData gd = new GridData(SWT.FILL,SWT.FILL,true,true);
		rasterCamera.setLayoutData(gd);

		Composite zoomComp = new Composite(this, SWT.NONE);
		zoomComp.setBackground(GUI.BGCOLOR);
		gd = new GridData(SWT.CENTER,SWT.BOTTOM,true,false);
		gd.widthHint = 220;
		zoomComp.setLayoutData(gd);
		GridLayout zoomLayout = new GridLayout(2,true);
		zoomLayout.horizontalSpacing=0;
		zoomLayout.marginWidth=20;
		zoomComp.setLayout(zoomLayout);

		GrpWdgMove moveGroup = new GrpWdgMove();
		
		WdgMotor wdgZoom = new WdgMotor(zoomComp,SWT.NONE,moveGroup,"Zoom",null,"camera_zoom_2", parent.getBackground(), new double[]{ 1, 2, 4, 6, 8, 10, 12 }, 2);
		wdgZoom.setBackground(parent.getBackground());
		wdgZoom.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, false, 2, 1));

		Button startButton = new Button(zoomComp, SWT.PUSH);
		startButton.setText("Start");
		startButton.setBackground(GUI.COLOR_BLUE_BUTTON);
		startButton.setFont(GUI.FONT_COLLECTRUN_BUTTON);
		moveGroup.setStartButton(startButton);
		startButton.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, false));
		
		Button cancelButton = new Button(zoomComp, SWT.PUSH);
		cancelButton.setText("Cancel");
		cancelButton.setBackground(GUI.COLOR_BLUE_BUTTON);
		cancelButton.setFont(GUI.FONT_COLLECTRUN_BUTTON);
		moveGroup.setCancelButton(cancelButton);
		cancelButton.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, false));
	}

	public void connectListeners()
	{
		//rotate.connectListeners();
	}
	
	public void notifyIsVisible(boolean isVisible)
	{
		rasterCamera.notifyIsVisible(isVisible);
	}
}
