package gov.anl.gmca.collect.viewer;

import gov.anl.gmca.io.Database;
import gov.anl.gmca.syslog.Log;

import java.util.ArrayList;
import java.util.HashMap;

public class ImgSrv
{
    public int index;
    public String id;
    public String display_name;
    public String base_url;

    private static ArrayList<ImgSrv> imgsrvList;

    public static void init()
    {
        try
        {
            imgsrvList = new ArrayList<>();
            Database.Result result = Database.exec(Database.DBName.CONFIG, "select * from ImageServer order by `index`");
            for (int i=0;i<result.numRows();i++)
            {
                HashMap<String,String> row = result.getRow(i);
                ImgSrv imgsrv = new ImgSrv();
                imgsrv.index = Integer.parseInt(row.get("index"));
                imgsrv.id = row.get("id");
                imgsrv.display_name = row.get("display_name");
                imgsrv.base_url = row.get("base_url");
                imgsrvList.add(imgsrv);
            }
        }
        catch (Exception e) { e.printStackTrace(); Log.error("Couldn't load external viewer list"); }
    }

    public static ArrayList<ImgSrv> getAll()
    {
        if (null==imgsrvList) init();
        return imgsrvList;
    }

    public static ImgSrv get(int index)
    {
        return imgsrvList.get(index);
    }
}


