package gov.anl.gmca.collect.viewer;

import gov.anl.gmca.collect.viewer.ZoomPanContrast.Histogram;
import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Composite;

public class WdgImageOptions
{
	private CTabFolder folder;
	private WdgDiffTab diffTab;
	private CTabItem item;
	public Composite comp;
	private Histogram histogram;
	
	public WdgImageOptions(CTabFolder folder, WdgDiffTab diffTab)
	{
		this.folder=folder; this.diffTab=diffTab;
		
		comp = new Composite(folder, SWT.NONE);
		comp.addPaintListener(new PaintListener()
		{
			@Override public void paintControl(PaintEvent e)
			{
				draw(e.gc);
			}
		});
		
		item = new CTabItem(folder, SWT.NONE);
		item.setText("Image");
		item.setControl(comp);
	}

	private void draw(GC gc)
	{
		Rectangle bounds = comp.getBounds();
		gc.setBackground(GUI.COLOR_LIGHT_GRAY);
		gc.fillRectangle(0, 0, bounds.width, bounds.height);
	
		if (null != histogram)
		{
			int maxVal = 0;
			for (int i=0; i<256; i++) if (histogram.values[i]>maxVal) maxVal=histogram.values[i];
			
			gc.setForeground(GUI.COLOR_BLACK);
			for (int i=0; i<bounds.width; i++)
			{
				int index = (int)((double)i/(double)bounds.width*(double)256.0);
				int lineHeight = (int)((double)histogram.values[index]/(double)maxVal*(double)bounds.height);
				gc.drawLine(i, bounds.height, i, bounds.height-lineHeight);
			}
		}
	}
	
	public void setHistogram(Histogram histogram)
	{
		this.histogram = histogram;
		GUI.asyncExec(new Runnable(){public void run(){comp.redraw();}});
	}
}
