package gov.anl.gmca.collect.viewer;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.gui.options.DevUserConfig;
import gov.anl.gmca.util.ListenerList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class WdgImgSrvSelector extends Composite
{
    private Combo combo;

    public WdgImgSrvSelector(Composite parent)
    {
        super(parent, SWT.NONE);

        setBackground(GUI.BGCOLOR);
        GridLayout gl = new GridLayout(2,false);
        gl.marginHeight=0;
        setLayout(gl);
        GridData gd = new GridData(SWT.FILL, SWT.CENTER, true, true);
        setLayoutData(gd);

        Label label = new Label(this, SWT.NONE);
        label.setText("Server: ");
        label.setFont(GUI.FONT_10);

        combo = new Combo(this, SWT.DROP_DOWN | SWT.READ_ONLY);
        combo.setFont(GUI.FONT_10);
        for (ImgSrv imgsrv : ImgSrv.getAll())
        {
            combo.add(imgsrv.display_name);
        }
        combo.select(DevUserConfig.get().getImgSrv().index);
        combo.addSelectionListener(new SelectionListener()
        {
            @Override public void widgetDefaultSelected(SelectionEvent se) {}
            @Override public void widgetSelected(SelectionEvent se)
            {
                int i = combo.getSelectionIndex();
                DevUserConfig.get().setImgSrv(i);
            }
        });

        connectListeners();
    }

    private int currentServer = -1;
    private void connectListeners()
    {
        DevUserConfig.get().ll.addListener(new ListenerList.Listener<DevUserConfig>()
        {
            @Override public void handleEvent(DevUserConfig config, Object data)
            {
                int i = config.getImgSrv().index;
                if (i!=currentServer) {
                    GUI.asyncExec(new Runnable(){public void run()
                    {
                        combo.select(i);
                    }});
                }
            }
        });
    }
}
