package gov.anl.gmca.collect.viewer;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.gui.options.DevUserConfig;
import gov.anl.gmca.util.ListenerList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class WdgViewerSelector extends Composite
{
	private Combo viewerCombo;
	
	public WdgViewerSelector(Composite parent)
	{
		super(parent, SWT.NONE);
		
		setBackground(GUI.BGCOLOR);
		GridLayout gl = new GridLayout(3,false);
		gl.marginHeight=0;
		setLayout(gl);
		GridData gd = new GridData(SWT.FILL, SWT.CENTER, true, true);
		setLayoutData(gd);

		Label viewerLabel = new Label(this, SWT.NONE);
		viewerLabel.setText("Viewer: ");
		viewerLabel.setFont(GUI.FONT_10);
		
		viewerCombo = new Combo(this, SWT.DROP_DOWN | SWT.READ_ONLY);
		viewerCombo.setFont(GUI.FONT_10);
		for (ExternalViewer viewer : ExternalViewer.getAll())
		{
			viewerCombo.add(viewer.name);
		}
		viewerCombo.select(DevUserConfig.get().getDisplayProgram().index);
		viewerCombo.addSelectionListener(new SelectionListener()
		{
			@Override public void widgetDefaultSelected(SelectionEvent se) {}
			@Override public void widgetSelected(SelectionEvent se)
			{
				int i = viewerCombo.getSelectionIndex();
				DevUserConfig.get().setDisplayProgram(i);
			}
		});
		
		Button viewerButton = new Button(this, SWT.PUSH);
		viewerButton.setFont(GUI.FONT_10);
		viewerButton.setText("\u25B6");
		viewerButton.setBackground(GUI.COLOR_BLUE_BUTTON);
		viewerButton.addSelectionListener(new SelectionListener()
		{
			@Override public void widgetDefaultSelected(SelectionEvent arg0) {}
			@Override public void widgetSelected(SelectionEvent arg0)
			{
				ExternalViewer.launch(null);
			}
		});
		
		connectListeners();
	}		
	
	private void connectListeners()
	{
		DevUserConfig.get().ll.addListener(new ListenerList.Listener<DevUserConfig>()
		{
			@Override public void handleEvent(DevUserConfig config, Object data)
			{
				int i = config.getDisplayProgram().index;
				GUI.asyncExec(new Runnable(){public void run()
				{
					viewerCombo.select(i);
				}});
			}
		});
	}
}
