package gov.anl.gmca.common;

import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PVName;
import gov.anl.gmca.io.PVLookup.PV_BLUICE;
import gov.anl.gmca.util.ListenerList;
import gov.aps.jca.dbr.DBR;

public class DevRuntimeConfig
{
	private static int[] values = null;
	private static final PVName pvName = PV_BLUICE.runtimeConfig;
	public static ListenerList<DevRuntimeConfig> llChange;

	public static enum IMPORT_SHOW_NUMBERS 	{ SHOW, HIDE; public static int index=0; }
	public static enum IMPORT_SHOW_SITES 	{ SHOW, HIDE; public static int index=1; }
	
	public static boolean getImportShowNumbers()
	{
		synchronized(values) {
			int val = values[IMPORT_SHOW_NUMBERS.index];
			return IMPORT_SHOW_NUMBERS.values()[val]==IMPORT_SHOW_NUMBERS.SHOW;
		}
	}
	public static void setImportShowNumbers(boolean b)
	{
		synchronized(values) {
			values[IMPORT_SHOW_NUMBERS.index] = b?IMPORT_SHOW_NUMBERS.SHOW.ordinal():IMPORT_SHOW_NUMBERS.HIDE.ordinal();
			Epics.putIntegerArray(pvName, values);
		}
	}
	public static boolean getImportShowSites()
	{
		synchronized(values) {
			int val = values[IMPORT_SHOW_SITES.index];
			return IMPORT_SHOW_SITES.values()[val]==IMPORT_SHOW_SITES.SHOW;
		}
	}
	public static void setImportShowSites(boolean b)
	{
		synchronized(values) {
			values[IMPORT_SHOW_SITES.index] = b?IMPORT_SHOW_SITES.SHOW.ordinal():IMPORT_SHOW_SITES.HIDE.ordinal();
			Epics.putIntegerArray(pvName, values);
		}
	}
	
	public static void init()
	{
		llChange = new ListenerList<>(null);
		
		Epics.addMonitor(pvName, new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, DBR value)
			{
				values = Epics.dbrToIntArray(value);
				llChange.notifyListeners();
			}
		});
		values = Epics.getIntegerArray(pvName);
	}
}
