package gov.anl.gmca.common;

import gov.anl.gmca.util.ListenerList;
import gov.anl.gmca.util.ListenerList.Listener;

import java.util.HashMap;

// tells listeners if any DevScript objects are running scripts
public class ModelScriptStatus
{
	public static ListenerList<ModelScriptStatus> ll = new ListenerList<ModelScriptStatus>(null);

	protected static HashMap<DevScript,Boolean> isRunningMap = new HashMap<DevScript,Boolean>();
	
	public static class ScriptStatus
	{
		public DevScript dev;
		public boolean isRunning;
		public ScriptStatus(DevScript ds, boolean ir) { this.dev=ds; this.isRunning=ir; }
	}
	
	protected synchronized static void updateState(DevScript dev, boolean isRunning)
	{
		if (isRunningMap.get(dev)!=isRunning)
		{
			isRunningMap.put(dev, isRunning);
			ll.notifyListeners(new ScriptStatus(dev,isRunning));
		}
	}
	
	public static void init()
	{
		for (DevScript dev : DevScript.getAll())
		{
			isRunningMap.put(dev,dev.isRunning());
			
			dev.ll.addListener(new Listener<DevScript>()
			{
				@Override public void handleEvent(DevScript dev, Object data)
				{
					updateState(dev, dev.isRunning());
				}
			});
		}
	}
}
