package gov.anl.gmca.common.ui;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.util.ListenerList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;

public class CButton extends Canvas implements PaintListener, MouseListener, MouseTrackListener
{
	private Image image;
	private boolean mouseHover=false;
	public void setImage(Image image) { this.image = image; }
	public ListenerList<CButton> ll;
	
	public CButton(Composite parent)
	{
		super(parent, SWT.NONE);
		ll = new ListenerList<CButton>(this);
		addPaintListener(this);
		addMouseListener(this);
		addMouseTrackListener(this);
	}

	@Override public void paintControl(PaintEvent pe)
	{
		if (null!=image) pe.gc.drawImage(image, 0, 0);
		if (mouseHover)
		{
			pe.gc.setForeground(GUI.COLOR_DARK_GRAY);
			pe.gc.drawRectangle(0,0,getBounds().width-1,getBounds().height-1);
			pe.gc.setForeground(GUI.COLOR_WHITE);
			pe.gc.drawRectangle(1,1,getBounds().width-3,getBounds().height-3);
		}
	}
	
	@Override public void mouseDoubleClick(MouseEvent me)
	{
		
	}
	@Override public void mouseDown(MouseEvent me)
	{
		
	}
	@Override public void mouseUp(MouseEvent me)
	{
		if (me.x>=0 && me.x<=getBounds().width && me.y>=0 && me.y<=getBounds().height)
		{
			ll.notifyListeners();
		}
	}
	@Override public void mouseEnter(MouseEvent arg0)
	{
		mouseHover=true; redraw();
	}
	@Override public void mouseExit(MouseEvent arg0)
	{
		mouseHover=false; redraw();
	}
	@Override public void mouseHover(MouseEvent arg0)
	{
		
	}
	
	@Override public Point getSize()
	{
		if (null!=image) return new Point(image.getBounds().width,image.getBounds().height);
		return new Point(50,50);
	}
	
	@Override public Point computeSize(int wHint, int hHint) { return getSize(); }
	@Override public Point computeSize(int wHint, int hHint, boolean changed) { return getSize(); }
}
