package gov.anl.gmca.common.ui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Item;
import org.eclipse.swt.widgets.Widget;

public class GTabItem extends Item
{
	private String text = "";
	private Control control = null;
	private GTabFolder folder = null;
	int index = -1;
	
	public GTabItem(Widget parent, int style)
	{
		super(parent, SWT.NONE);
		folder = (GTabFolder)parent;
		index = folder.addTab(this);
		
		addDisposeListener(new DisposeListener()
		{
			@Override public void widgetDisposed(DisposeEvent arg0)
			{
				folder.removeTab(index);
			}
		});
	}
	
	public String getText()
	{
		return text;
	}
	
	public void setText(String text)
	{
		this.text = text;
		folder.tabCol.setTabText(index, text);
	}
	
	public void setControl(Control control)
	{
		this.control = control;
		control.setParent(folder.stackComp);
	}
	
	public Control getControl()
	{
		return control;
	}
}
