package gov.anl.gmca.common.ui;

import gov.anl.gmca.common.SafeImageDelete;
import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

import java.util.ArrayList;

public class NBDlgDelete extends NBDialog
{
	protected ArrayList<SafeImageDelete.FileToDelete> _fileList = null;
	
	public NBDlgDelete(ArrayList<SafeImageDelete.FileToDelete> fileList)
	{
	    super(GUI.getShell(), SWT.APPLICATION_MODAL|SWT.DIALOG_TRIM);
		_fileList = fileList;
		if (0 == _fileList.size()) throw new IllegalArgumentException("Delete dialog called with zero files");
		setText("Delete existing files?");
	}
	
	@Override protected void createContents(Composite parent)
	{
        // disable 'x' button in top right corner
        dialogShell.addListener (SWT.Close, new Listener () {
    		public void handleEvent (Event event) {
    			event.doit = false;
    		}
    	});
        
        GridLayout gl = new GridLayout(2,false);
        gl.marginWidth = 10;
        gl.marginHeight = 10;
        gl.verticalSpacing = 10;
        parent.setLayout(gl);
        GridData gd = null;
    	
        Label lblIcon = new Label(parent,SWT.NONE);
        lblIcon.setImage(Display.getDefault().getSystemImage(SWT.ICON_WARNING));
        gd = new GridData();
        lblIcon.setLayoutData(gd);
        
        Label lbl = new Label(parent,SWT.NONE);
        lbl.setText("The following files already exist. Do you want to delete them?");
        gd = new GridData();
        lbl.setLayoutData(gd);
        
        List list = new List(parent,SWT.V_SCROLL|SWT.H_SCROLL);
        gd = new GridData();
        gd.horizontalSpan=2;
        gd.horizontalAlignment=SWT.FILL;
        gd.grabExcessHorizontalSpace=true;
        gd.widthHint = 300;
        gd.heightHint = 200;
        list.setLayoutData(gd);
    
        for (int i=0;i<_fileList.size();i++)
        {
            list.add(_fileList.get(i).getFullPath());
        }
        
        Label lbl2 = new Label(parent,SWT.NONE);
        lbl2.setText("Proceed with deletion?");
        gd = new GridData();
        gd.horizontalSpan=2;
        lbl2.setLayoutData(gd);
    
        Composite buttonComp = new Composite(parent,SWT.NONE);
        gd = new GridData();
        gd.horizontalSpan=2;
        gd.grabExcessHorizontalSpace=true;
        gd.horizontalAlignment=SWT.FILL;
        buttonComp.setLayoutData(gd);
        buttonComp.setLayout(new GridLayout(2,false));
        
        Button b1 = new Button(buttonComp,SWT.NONE);
        b1.setText("Delete");
        gd = new GridData();
        gd.grabExcessHorizontalSpace=true;
        gd.horizontalAlignment=SWT.FILL;
        b1.setLayoutData(gd);
        b1.addSelectionListener(new SelectionListener()
        {
			public void widgetDefaultSelected(SelectionEvent arg0) {}

			public void widgetSelected(SelectionEvent arg0)
			{
				returnValue = SWT.OK;
				closeDialog();
			}
		});
        
        Button b2 = new Button(buttonComp,SWT.NONE);
        b2.setText("Cancel");
        gd = new GridData();
        gd.grabExcessHorizontalSpace=true;
        gd.horizontalAlignment=SWT.FILL;
        b2.setLayoutData(gd);
        b2.addSelectionListener(new SelectionListener()
        {
			public void widgetDefaultSelected(SelectionEvent arg0) {}

			public void widgetSelected(SelectionEvent arg0)
			{
				returnValue = SWT.CANCEL;
				closeDialog();
			}
		});
        
        dialogShell.setDefaultButton(b2);
	}
}
