package gov.anl.gmca.diffimage;

import gov.anl.gmca.common.Units;
import org.eclipse.swt.graphics.Image;

import java.awt.image.BufferedImage;

public abstract class DiffractionImage
{
	public abstract boolean hasValidImage();
	public abstract int origWidth();
	public abstract int origHeight();
	
	public BufferedImage contrastImg;
	public Image screenImg;
	public double wavelength_A, distance_mm, beam_center_mm_from_left, beam_center_mm_from_top;
	public double mmPerPixel;
	public double exposureTime_sec;
	public double delta_degr;
	public String detector;
	public double gray=0;

	public DiffractionImage(){}
	
	public double getWavelength_keV() { return Units.angstrom_to_keV(wavelength_A); }
	
	protected void createContrastImage()
	{
		if (null==contrastImg)
		{
			contrastImg = new BufferedImage
			(
				origWidth(),
				origHeight(),
				BufferedImage.TYPE_BYTE_GRAY
			);
		}
	}
	
	public abstract void setContrast(double gray);

	// public void setContrast(double gray)
	// {
		/*HashMap<Integer,Integer> histogram = new HashMap<>();
		DataBuffer buf = originalImg.getData().getDataBuffer();
		for (int i=0;i<buf.getSize();i++)
		{
			int c = buf.getElem(i);
			if (!histogram.containsKey(c)) histogram.put(c, 1);
			else histogram.put(c, histogram.get(c)+1);
		}
		for (Integer key : histogram.keySet())
		{
			System.out.println(key+": "+histogram.get(key));
		}*/
		
		/*
		//for (int i=0;i<originalImg.getWidth();i++)
		{
			//for (int j=0;j<originalImg.getHeight();j++)
			for (int i=0;i<buf.getSize();i++)
			{
				int c = buf.getElem(i);//originalImg.getRGB(i, j) & 0x00FFFFFF;
				if (!histogram.containsKey(c)) histogram.put(c, 1);
				else histogram.put(c, histogram.get(c)+1);
			}
		}
		int count=0, max=0;
		for (Integer key : histogram.keySet())
		{
			//Util.printf("Value %08x seen %d times", key, histogram.get(key));
			//if (count++ > 10) break;
			if (histogram.get(key)>max) max=histogram.get(key);
		}
		System.out.println("max val = "+max);*/
		
		//g2d.get
		//BufferedImageOp contrastOp = new RescaleOp(-10000f, 65535f, null);
		//g2d.drawImage(originalImg, contrastOp, 0, 0);
		
		//g2d.dispose();
	//}
}
