package gov.anl.gmca.diffimage;

import gov.anl.gmca.io.Web;
import gov.anl.gmca.syslog.Log;

public class EigerMonitorImage extends DiffractionImage
{
    // send null for current image
    public EigerMonitorImage()
    {
        Web.WebConnection conn = Web.get().openConnection("http://164.54.103.?/monitor/api/1.6.x/images/monitor");
        conn.waitForThread();
        if (200 != conn.getResponseCode())
        {
            Log.error("Eiger monitor returned code " + conn.getResponseCode());
        }
        else
        {
            /*byte[] tifImage = conn.content;
            ImageLoader loader = new ImageLoader();
            loader.load(new ByteArrayInputStream(tifImage));
            imageData = loader.data[0];*/
            detector = "EIGER";
            beam_center_mm_from_left =0;
            beam_center_mm_from_top =0;
            distance_mm=900;
            exposureTime_sec=1.0;
            mmPerPixel=0.01;
            wavelength_A=12;
        }
    }

	@Override public boolean hasValidImage() {return false;}
	@Override public int origWidth() { return 0; }
	@Override public int origHeight() { return 0; }
	@Override public void setContrast(double gray) {}
}
