package gov.anl.gmca.diffimage;

import com.sun.media.jai.codec.FileSeekableStream;
import com.sun.media.jai.codec.TIFFDecodeParam;
import gov.anl.gmca.util.PerfTimer;

import javax.media.jai.JAI;
import javax.media.jai.RenderedOp;
import java.awt.image.renderable.ParameterBlock;

public class MARImage extends DiffractionImage16Bit
{
    public MARImage(String filename)
    {
    	try
    	{
    		PerfTimer pt = new PerfTimer("TIFF img load: ");
    		
    		// load
	    	FileSeekableStream stream = new FileSeekableStream(filename);
	    	TIFFDecodeParam decodeParam = new TIFFDecodeParam();
	    	decodeParam.setDecodePaletteAsShorts(true);
	    	ParameterBlock params = new ParameterBlock();
	    	params.add(stream);
	    	RenderedOp image1 = JAI.create("tiff", params);
	    	originalImg = image1.getAsBufferedImage();
	    	
	    	setContrast(100);
	    	pt.printElapsedMs();
    	}
    	catch (Exception e) { e.printStackTrace(); }
    	
    	detector = "MAR";
        beam_center_mm_from_left =0;
        beam_center_mm_from_top =0;
        distance_mm=900;
        exposureTime_sec=1.0;
        mmPerPixel=0.01;
        wavelength_A=12;
    }
}
