/**
 * This class creates a thread 
 * and runs qconf -sh command to check if the current host is in the list.
 */
package gov.anl.gmca.gridengine;

import gov.anl.gmca.io.ExecTask;

public class CheckSubmitHost {
	
	protected static CheckSubmitHost single = null;
	
	public static CheckSubmitHost get() {
		return single;
	}
	public CheckSubmitHost() {
		single = this;
	}
	public boolean isSubmitHost() {
		
		String currenthost = System.getenv("HOSTNAME");
		
		/* run qconf -sh command and get hosts*/
		ExecTask et = ExecTask.new_ExecTask("qconf -sh", "Grid Engine Check:", false, false);
		et.start();
		et.waitFor();
		
		String[] hosts = et.stdoutString().split("\\r?\\n");
		
		/* check host in the list */
		for(String host: hosts) {
			if(host.contains(currenthost)) {
				return true;
			}
		}
		return false;
	}
}
