package gov.anl.gmca.gridengine;

import gov.anl.gmca.syslog.Log;
import org.ggf.drmaa.DrmaaException;
import org.ggf.drmaa.JobTemplate;
import org.ggf.drmaa.Session;
import org.ggf.drmaa.SessionFactory;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Collections;

public class TestSGE {
	public void test1() {
		new CheckSubmitHost();
		boolean isSGE = CheckSubmitHost.get().isSubmitHost();

		if (!isSGE) {
			Log.note(System.getenv("HOSTNAME") + " is NOT a SGE host.");
		} else {
			Log.note(System.getenv("HOSTNAME") + " is a SGE host.");
		}
	}

	public void test2(String script2run, String workDir) {
		try {
			DRMAA drmaa = new DRMAA(script2run, workDir, 900);
			drmaa.start();
			drmaa.waitFor();
			Log.error("test2 done");
		} catch (UnsatisfiedLinkError | Exception e) {
			StringWriter stack = new StringWriter();
			e.printStackTrace(new PrintWriter(stack));
			Log.error("Caught exception : " + stack.toString());
		}
	}

	public void test3() {

		//System.setProperty("java.library.path", "/opt/sge/lib/lx-amd64");
		//System.loadLibrary("drmaa");
		//try {
		//	Class.forName("org.ggf.drmaa");
		//} catch (ClassNotFoundException e1) {
		//	e1.printStackTrace();
		//}
		System.out.println(System.getenv("LD_LIBRARY_PATH"));
		System.out.println(System.getProperty("java.class.path"));

		SessionFactory factory = SessionFactory.getFactory();
		Session session = factory.getSession();

		try {
			session.init("");
			JobTemplate jt = session.createJobTemplate();
			jt.setRemoteCommand("/mnt/beegfs/user1/sgeTest.java/sleeper.sh");
			jt.setArgs(Collections.singletonList("5"));

			String id = session.runJob(jt);

			System.out.println("Your job has been submitted with id " + id);

			session.deleteJobTemplate(jt);
			session.exit();
		} catch (DrmaaException e) {
			System.out.println("Error: " + e.getMessage());
		}
	}

	public void tests() {
		//test1();
		Log.error(System.getenv("LD_LIBRARY_PATH"));
		Log.error(System.getProperty("java.class.path"));
		test2("/mnt/share/qxu/test1/sleep.sh", "/mnt/share/qxu/test1/");
	}

}
