package gov.anl.gmca.gui.options;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

public class WdgControlAction
{
	private Button button;
	public WdgControlAction(Composite parent, String text, final Runnable handler)
	{
		button = new Button(parent, SWT.PUSH);
		button.setText(text);
		GridData gd = new GridData();
		gd.widthHint = 250;
		gd.heightHint = 28;
		
		button.setLayoutData(gd);
		button.addSelectionListener(new SelectionListener()
		{
			@Override public void widgetSelected(SelectionEvent e)
			{
				handler.run();
			}
			@Override public void widgetDefaultSelected(SelectionEvent e) {}
		});
	}
	public void setEnabled(boolean enable)
	{
		button.setEnabled(enable);
	}
}


