package gov.anl.gmca.hutch;

import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_MISC;
import gov.anl.gmca.util.ListenerList;
import gov.aps.jca.dbr.DBR;

// Since this device only covers IZero for now, it does not support reading from arbitrary channels.
// That can be added later if needed.
public class DevADC
{
	public static ListenerList<DevADC> llIZero = new ListenerList<DevADC>(null);

	public static double getIZero() { return Epics.getDouble(PV_MISC.localIZero); }

	public static void init()
	{
    	Epics.addMonitor(PV_MISC.localIZero, new Epics.EpicsValueMonitor()
    	{
    		@Override public void valueChanged(String pvName, DBR value)
    		{
    			llIZero.notifyListeners(Epics.dbrToDouble(value));
    		}
    	});
    }
}
