package gov.anl.gmca.hutch;

import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_MISC;
import gov.anl.gmca.util.ListenerList;
import gov.aps.jca.dbr.DBR;

public class DevAPSStatus
{
	public static ListenerList<DevAPSStatus>
		llCurrent = new ListenerList<DevAPSStatus>(null),
		llShutterPermit = new ListenerList<DevAPSStatus>(null),
		llEndStationSecure = new ListenerList<DevAPSStatus>(null);
	
	public static double 	getCurrent() 				{ return Epics.getDouble(PV_MISC.apsCurrent); }
	public static boolean 	isShutterPermitEnabled() 	{ return 1==Epics.getInteger(PV_MISC.apsShutterStat); }
	public static boolean 	isEndstationSecure()		{ return 1==Epics.getInteger(PV_MISC.stationSearched);}
	
	public static void init()
	{
		Epics.addMonitor(PV_MISC.apsCurrent, new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, DBR value)
			{
				llCurrent.notifyListeners(Epics.dbrToDouble(value));
			}
		});
		
		Epics.addMonitor(PV_MISC.apsShutterStat, new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, DBR value)
			{
				llShutterPermit.notifyListeners(1==Epics.dbrToInt(value));
			}
		});
		
		Epics.addMonitor(PV_MISC.stationSearched, new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, DBR value)
			{
				llEndStationSecure.notifyListeners(1==Epics.dbrToInt(value));
			}
		});
	}
}
