package gov.anl.gmca.hutch;

import java.util.ArrayList;

public class DevFilter extends DevShutter
{
	protected Material material = null;
	public Material getMaterial() { return material; }
	
	protected double thickness = Double.NaN;
	public double getThickness() { return thickness; }
	
	protected static ArrayList<DevFilter> enabledFilterList = new ArrayList<DevFilter>();
	public static ArrayList<DevFilter> getEnabledFilters() { return enabledFilterList; }
	
	protected static ArrayList<DevFilter> disabledFilterList = new ArrayList<DevFilter>();
	public static ArrayList<DevFilter> getDisabledFilters() { return disabledFilterList; }
	
	public DevFilter(String name, Material material, double thickness, boolean enable)
	{
		super(name);
		
		this.material = material;
		this.thickness = thickness;
		
		if (enable)
		{
			enabledFilterList.add(this);
		}
		else
		{
			disabledFilterList.add(this);
		}
	}
}
