package gov.anl.gmca.hutch;

import gov.anl.gmca.common.EpicsDevice.State;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.hutch.DevShutter.Listener;
import gov.anl.gmca.util.ListenerList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;

public class WdgBeam extends Canvas implements PaintListener
{
	private boolean esShutterOpen=false, fastShutterOpen=false;
	private boolean reqES, reqFast;
	
	public WdgBeam(Composite parent, boolean needsESShutterOpen, boolean needsFastShutterOpen)
	{
		super(parent, SWT.NONE);
		addPaintListener(this);
		reqES = needsESShutterOpen;
		reqFast = needsFastShutterOpen;

		DevShutter.get("shutter").listenerSet.add(new Listener()
		{
			@Override public void handleStateChange(DevShutter shutter, State state) {}
			@Override public void handleOpenChange(DevShutter shutter, final boolean open)
			{
				GUI.asyncExec(new Runnable(){public void run()
				{
					fastShutterOpen = open;
					updateState();
				}});
			}
		});
		fastShutterOpen = DevShutter.get("shutter").getIsOpen();
		
		DevHutchShutter.get("endStation").ll.addListener(new ListenerList.Listener<DevHutchShutter>()
		{
			@Override public void handleEvent(DevHutchShutter object, final Object data)
			{
				GUI.asyncExec(new Runnable(){public void run()
				{
					esShutterOpen = (Boolean)data;
					updateState();
				}});
			}
		});
		esShutterOpen = DevHutchShutter.get("endStation").isOpen();
		
		updateState();
	}
	
	private void updateState()
	{
		boolean show = true;
		if (reqES && !esShutterOpen) show = false;
		if (reqFast && !fastShutterOpen) show = false;
		setVisible(show);
	}
	
	@Override public void paintControl(PaintEvent e)
	{
		int width = getBounds().width;
		e.gc.setForeground(GUI.COLOR_PURPLE3);
		e.gc.drawLine(0, 0, width, 0);
		e.gc.drawLine(0, 4, width, 4);
		e.gc.setForeground(GUI.COLOR_PURPLE2);
		e.gc.drawLine(0, 1, width, 1);
		e.gc.drawLine(0, 3, width, 3);
		e.gc.setForeground(GUI.COLOR_PURPLE1);
		e.gc.drawLine(0, 2, width, 2);
	}
}
