package gov.anl.gmca.io;

import gov.anl.gmca.gui.Main;
import gov.anl.gmca.util.Util;

import java.util.HashMap;

public abstract class Web
{
    protected static Web inst = null;
    public static Web get()
    {
    	if (null != inst) return inst;
		if (Main.SIM_LEVEL==2)	{ inst = new gov.anl.gmca.io.sim.Web(); return inst; }
		else					{ inst = new gov.anl.gmca.io.hw.Web(); return inst; }
	}
	
	public abstract WebConnection openConnection(String url, int timeoutMs);
	public WebConnection openConnection(String url) { return openConnection(url, 0); }

	public abstract static class WebConnection
	{
		public Thread thread;
		
		// the one inherited method, since it works very differently in HW and SIM modes
		abstract public void abort();
		
		public boolean isRunning() { return thread.isAlive(); }
		
		public int responseCode = -1;
		public boolean responseOK() { waitForThread(); return 200==responseCode; }
		public int getResponseCode() { waitForThread(); return responseCode; }
		
		// the following two get methods block until the HTTP connection is closed
		// don't access the variables directly!  use the get methods
		// (TODO: prevent direct access if possible)
		public byte[] content;
		public byte[] getResponse() { waitForThread(); return content; }
		
		public HashMap<String,String> headers = new HashMap<String,String>();
		public HashMap<String, String> getHeaders() { waitForThread(); return headers; }
		
		public void waitForThread() { while (isRunning()) Util.sleep(10); }
	}
}
