package gov.anl.gmca.io.sim.dev;

import gov.anl.gmca.gui.Main;
import gov.anl.gmca.io.sim.Disk;
import gov.anl.gmca.util.Util;

import java.util.ArrayList;

// chooch takes as input a .dat file written by BluIce
// chooch outputs an .efs file (numerical) and a .ps file (graphical)
//
public class SimChooch implements Runnable
{
	private static final String fakeEFSPath = Main.getAppDir()+"/data/fake_EDGE_Se_K.efs";
	private static final String fakePSPath = Main.getAppDir()+"/data/fake_EDGE_Se_K_chooch.ps";
	
	private String element, edge, efsPath, psPath, datPath;
	private ArrayList<String> stdOut, stdErr;
	
	public SimChooch(String element, String edge, String efsPath, String psPath, String datPath, ArrayList<String> stdOut, ArrayList<String> stdErr)
	{
		this.element=element;
		this.edge=edge;
		this.efsPath=efsPath;
		this.psPath=psPath;
		this.datPath=datPath;
		this.stdOut=stdOut;
		this.stdErr=stdErr;
	}
	
	@Override public void run()
	{
		stdErr.add("==================================================");
		stdErr.add("                     SimChooch                    ");
		stdErr.add("                  by Mark Hilgart                 ");
		stdErr.add("                 mhilgart@anl.gov                 ");
		stdErr.add("==================================================");
		
		Util.sleep(1000);
		
		stdOut.add(" Table of results");
		stdOut.add("------------------------------------");
		stdOut.add("|      |  energy  |    f'' |   f'  |");
		stdOut.add("| peak | 12658.72 |   6.30 | -8.41 |");
		stdOut.add("| infl | 12656.60 |   3.33 | -10.29 |");
		stdOut.add("------------------------------------");
		
		if (null != efsPath) Disk.copyFile(fakeEFSPath, efsPath);
		if (null != psPath)  Disk.copyFile(fakePSPath, psPath);
	}
}
