package gov.anl.gmca.io.sim.dev;

import gov.anl.gmca.io.PVLookup.PV_HUTCH_SHUTTER;
import gov.anl.gmca.io.sim.Epics;
import gov.anl.gmca.util.Util;
import gov.aps.jca.dbr.DBR;

public class SimHutchShutter
{
	private String devName;
	
	public SimHutchShutter(final String devName, boolean startOpen)
	{
		this.devName=devName;
		System.out.println("Creating sim hutch shutter "+devName);
		
		Epics.putInteger(PV_HUTCH_SHUTTER.stat.shutter(devName), startOpen?0:1);
		
		Epics.addMonitor(PV_HUTCH_SHUTTER.open.shutter(devName), new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, final DBR value)
			{
				if (1==Epics.dbrToInt(value)) handleMove(true);
			}
		});
		Epics.addMonitor(PV_HUTCH_SHUTTER.close.shutter(devName), new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, final DBR value)
			{
				if (1==Epics.dbrToInt(value)) handleMove(false);
			}
		});
	}
	
	private void handleMove(final boolean open)
	{
		new Thread(new Runnable(){public void run()
		{
			Util.sleep(1000);
			Epics.putInteger(PV_HUTCH_SHUTTER.stat.shutter(devName), open?0:1);
		}}, "SimHutchShutter "+devName+" open="+open).start();
	}
}
