package gov.anl.gmca.io.sim.dev;

import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_BLUICE;
import gov.anl.gmca.util.Util;
import gov.aps.jca.dbr.DBR;

public class SimSampleServer
{
	public SimSampleServer()
	{
		Epics.addMonitor(PV_BLUICE.sampleEnv, new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, DBR value)
			{
				String val = Epics.dbrToString(value);
				if (val.equals("accepted")||val.equals("finished")) return;
				
				new Thread(new Runnable(){public void run()
				{
					Epics.put(PV_BLUICE.sampleEnv, "accepted");
					Util.sleep(1000);
					Epics.put(PV_BLUICE.sampleEnv, "finished");
				}}, "SimSampleServer").start();
			}
		});
	}
}
