package gov.anl.gmca.io.sim.dev;

import gov.anl.gmca.io.PVLookup.PV_SHUTTER;
import gov.anl.gmca.io.sim.Epics;
import gov.anl.gmca.util.Util;
import gov.aps.jca.dbr.DBR;

public class SimShutter
{
	public SimShutter(final String devName, boolean startOpen)
	{
		System.out.println("Creating sim shutter "+devName);
		
		Epics.putInteger(PV_SHUTTER.control.shutter(devName), startOpen?1:0);
		Epics.putInteger(PV_SHUTTER.readback.shutter(devName), startOpen?1:0);
		
		Epics.addMonitor(PV_SHUTTER.control.shutter(devName), new Epics.EpicsValueMonitor()
		{
			@Override public void valueChanged(String pvName, final DBR value)
			{
				new Thread(new Runnable(){public void run()
				{
					Util.sleep(50);
					Epics.putInteger(PV_SHUTTER.readback.shutter(devName), Epics.dbrToInt(value));
				}}, "SimShutter "+devName).start();
			}
		});
	}
}
