package gov.anl.gmca.raster.cam;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.raster.ModelRasterCell;
import gov.anl.gmca.raster.ModelRasterGrid;
import gov.anl.gmca.raster.ModelRasterState;
import gov.anl.gmca.util.SwingUtil;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;

import java.awt.*;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.concurrent.atomic.AtomicBoolean;

public class DrawCreateSite
{
	private ModelRasterVideo model;
	public DrawCreateSite(ModelRasterVideo model)
	{
		this.model=model;
	}

	protected void drawSiteHighlight(Graphics2D g2)
	{
		// fill in selected cells on the buffer
		ArrayList<AtomicBoolean> currentHit = model.vcCreateSite.hit;
		if (null != currentHit)
		{
			ArrayList<AtomicBoolean> ss = new ArrayList<AtomicBoolean>(currentHit);
			ModelRasterGrid grid = ModelRasterState.get().getCurrentRunModel().grid();
			g2.setColor(Color.WHITE);
			g2.setBackground(Color.WHITE);
			for (int cellnum=0; cellnum<ss.size(); cellnum++)
			{
				boolean selected = ss.get(cellnum).get();
				if (selected)
				{
					ModelRasterCell cell = grid.getCellCopy(cellnum);
					
					// default cell bounds include top and left borders
					// here we remove them to highlight only the center of each cell and
					// leave a border
					Rectangle cellBounds = model.getCellScreenBounds(cell);
					if (null==cellBounds) continue;
					cellBounds.x++;
					cellBounds.y++;
					cellBounds.width--;
					cellBounds.height--;
					//cellBounds.x += model.cam.drawX;
					//cellBounds.y += model.cam.drawY;
					
					AlphaComposite ac = AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 200.0f/255.0f);
					g2.fillRect(cellBounds.x, cellBounds.y, cellBounds.width, cellBounds.height);
				}
			}
		}
	}
}
