package gov.anl.gmca.raster.cam;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.raster.cam.ModelRasterVideo.VideoState;
import gov.anl.gmca.util.WidgetFactory;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class WdgPointAndClick extends Composite
{
	private ModelRasterVideo model;
	private Button btnChangeMode;
	private Label label;

	public WdgPointAndClick(Composite parent, ModelRasterVideo model)
	{
		super(parent, SWT.NONE);
		
		this.model=model;
		final ModelRasterVideo fModel = model;
		setBackground(GUI.COLOR_DARK_GREEN);
		
		GridLayout gl = new GridLayout(2, false);
		gl.marginWidth=1;
		gl.marginHeight=1;
		gl.horizontalSpacing=0;
		setLayout(gl);
		setBackground(GUI.COLOR_BLACK);
		
		Composite labelComp = new Composite(this, SWT.NONE);
		labelComp.setBackground(GUI.COLOR_DARK_GREEN);
		gl = new GridLayout(2,false);
		gl.marginHeight=2;
		labelComp.setLayout(gl);
		labelComp.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		
		label = new Label(labelComp, SWT.LEFT);
		label.setBackground(GUI.COLOR_DARK_GREEN);
		label.setForeground(GUI.COLOR_WHITE);
		label.setText("Point and click to move sample position");
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));
		
		btnChangeMode = WidgetFactory.newButton(labelComp, SWT.PUSH, "View");
		btnChangeMode.setFont(GUI.FONT_10);
		btnChangeMode.addSelectionListener(new SelectionListener()
		{
			@Override public void widgetSelected(SelectionEvent se)
			{
				fModel.changeState(VideoState.VIEW_IMAGES);
			}
			@Override public void widgetDefaultSelected(SelectionEvent se) {}
		});
	}		
}
