package gov.anl.gmca.raster.ui;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.raster.ModelRasterCell;
import gov.anl.gmca.raster.cam.VCViewImages;
import gov.anl.gmca.raster.cam.WdgRasterCamera;
import gov.anl.gmca.util.ListenerList.Listener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class WdgCellInfo extends Composite
{
	private StyledText st;
	
	public WdgCellInfo(Composite parent, WdgRasterCamera rasterCam)
	{
		super(parent, SWT.BORDER);
		GridLayout gl = new GridLayout(2,false);
		gl.verticalSpacing = 1;
		setLayout(gl);
		setBackground(GUI.BGCOLOR);
		
		Label l = new Label(this, SWT.CENTER);
		l.setText("SpotFinder Results");
		l.setBackground(getBackground());
		l.setFont(GUI.FONT_14);
		l.setLayoutData(new GridData(SWT.FILL, SWT.DEFAULT, true, false, 2, 1));
		
		Composite spacer = new Composite(this, SWT.NONE);
		spacer.setBackground(getBackground());
		GridData gd = new GridData(SWT.FILL, SWT.DEFAULT, true, false, 2, 1);
		gd.heightHint=5;
		spacer.setLayoutData(gd);
		
		st = new StyledText(this, SWT.LEFT|SWT.V_SCROLL);
		gd = new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1);
		st.setLayoutData(gd);
		st.setBackground(GUI.COLOR_WHITE);
		
		rasterCam.model.vcViewImages.llSelectedCell.addListener(new Listener<VCViewImages>()
		{
			@Override public void handleEvent(VCViewImages object, Object data)
			{
				GUI.asyncExec(new Runnable(){public void run()
				{
					handleCellChange((ModelRasterCell)data);
				}});
			}
		});
	}
	
	public void handleCellChange(ModelRasterCell cell){}
}
