package gov.anl.gmca.raster.ui;

import gov.anl.gmca.common.ui.WdgControl;
import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.raster.ModelRasterRun.ROIMode;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

public class WdgControlROI extends WdgControl
{
	protected Label lblROI;
	protected Combo comboROI;
	
	public WdgControlROI(Composite parent, int style, ModelInterface _mi)
	{
		super(parent, style, _mi);

		setBackground(GUI.BGCOLOR);
		GridLayout roiLayout = new GridLayout(2,false);
		roiLayout.marginWidth=0;
		roiLayout.marginHeight=0;
		setLayout(roiLayout);
		
		lblROI = new Label(this,SWT.NONE);
		lblROI.setBackground(GUI.BGCOLOR);
		lblROI.setText("ROI:");
		GridData gd = new GridData();
		lblROI.setLayoutData(gd);

		comboROI = new Combo(this, SWT.READ_ONLY);

		// Choices are added in the enum's order, so setting can be done the same way
		for (ROIMode mode : ROIMode.values())
		{
			comboROI.add(mode.guiString());
		}
		
		comboROI.select(0);
		comboROI.setEnabled(false);

		gd = new GridData();
		gd.horizontalAlignment=SWT.FILL;
		gd.grabExcessHorizontalSpace=true;
		comboROI.setLayoutData(gd);
		
		comboROI.addSelectionListener(new SelectionListener()
		{
			@Override public void widgetSelected(SelectionEvent e)
			{
				mi.setValue(ROIMode.values()[comboROI.getSelectionIndex()]);
			}
			@Override public void widgetDefaultSelected(SelectionEvent e) {}
		});
	}
	
	@Override
	public void setEnabled(boolean enable)
	{
		comboROI.setEnabled(enable);
	}
	
	public void setSelection(ROIMode newMode)
	{
		comboROI.select(newMode.ordinal());
	}

	@Override
	public boolean updateModel()
	{
		return true;
	}
}
