package gov.anl.gmca.scan;

import gov.anl.gmca.sample.DevCollimatorCtrl;
import gov.anl.gmca.scan.ModelScan.AutoStep;

public class CmdCleanup extends CmdScan
{
	public static enum Mode { INTER, AUTO };
	protected Mode mode;
	
	//protected ActionResult result = null;
	
	public CmdCleanup(Mode mode) { this.mode=mode; }
	
	@Override
	public void run()
	{
		if (Mode.AUTO == mode)
		{
    		DevScan.get().setAutoStep(AutoStep.RETRACT, true);
    		
    		// park fl. detector
    		DevFluoCleanup.run();
    		
    		// backlight in
    		DevCollimatorCtrl.CCMove ccMove = DevCollimatorCtrl.get().newMove();
    		ccMove.setArguments("OUT backlightIN bluice");
    		//ccMove.setDest("backlight", InOut.IN);
    		ccMove.start();

    		DevScan.get().setAutoStep(AutoStep.NONE, true);
		}
		else
		{
    		DevFluoCleanup.run();
		}
	}
	
	/*public ActionResult getResult()
	{
		return result;
	}*/
	
	@Override
	public void requestStop()
	{
		DevFluoCleanup.stop();
	}
}
