package gov.anl.gmca.scan;

import gov.anl.gmca.common.DBConfig;
import gov.anl.gmca.gui.Main;
import gov.anl.gmca.io.ExecTask;
import gov.anl.gmca.scan.ModelScan.InterStep;
import gov.anl.gmca.syslog.Log;
import gov.anl.gmca.util.Util;

public class DevFluoCleanup
{
    protected 	static final String scriptFile 		= "parkFluoDetector.pl";
		
	protected static ExecTask task = null;
	
	public static void run()
	{
		// handled by CmdCleanup.stop()
		//WdgEmergencyStop.registerProcess(scriptFile);
		
		DevScan.get().setInterStep(InterStep.CLEANUP, true);
		
		if (Main.SIM_LEVEL>=1)		runSim();
		else						runScript();
		
		DevScan.get().setInterStep(InterStep.IDLE, true);
	}
	
	protected static void runScript()
	{
		if (null != task && task.isRunning())
		{
			Log.error(scriptFile+" is already running, aborting.");
			return;
		}
		
		String cmd = 
			Util.getPerlPrefix()+scriptFile+" "+
			DBConfig.get("app_beamlineID");
		
		task = ExecTask.new_ExecTask(cmd, scriptFile, true);
		task.start();
		task.waitFor();
		
		if (0 != task.exitValue)
		{
			Log.warn(scriptFile+" returned "+task.exitValue);
		}
		
		DevScan.get().setAutoOptimized(false, true);
	}
	
	public static void stop()
	{
		if (task.isRunning()) task.asyncStop();
	}
	
	protected static void runSim()
	{
		Util.sleep(3000);
		DevScan.get().setAutoOptimized(false, true);
	}
}
