/**
 * @author spothineni
 * 
 * This is GUI for ClearResults button
 * 
 */

package gov.anl.gmca.screening.ui;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.screening.ModelScreening;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

public class WdgClearColorCode extends Dialog{
	
	protected Shell messageDialog = null;
	protected int buttonPressed = -1;
	
	public WdgClearColorCode(Shell parent, int style, String message) {
		super(parent, style);
	}
	public int open(boolean[] clearPucks) {
		Shell parent = getParent();
		messageDialog = new Shell(parent, SWT.DIALOG_TRIM);
		messageDialog.setText("Clear Color Code");

		GridLayout gl = new GridLayout(2, false);
		gl.marginWidth = 10;
		gl.marginHeight = 10;
		gl.verticalSpacing = 10;
		messageDialog.setLayout(gl);

		Composite expandComp = new Composite(messageDialog, SWT.NONE);
		expandComp.setBackground(GUI.BGCOLOR);
		GridLayout gl1 = new GridLayout(2, false);
		expandComp.setLayout(gl1);
		GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true);
		expandComp.setLayoutData(gd);
		expandComp.setLayout(gl1);
		
		gd = new GridData(SWT.CENTER, SWT.FILL, false, true);
		Label warnLabel = new Label(expandComp, SWT.NONE);
		warnLabel.setBackground(GUI.BGCOLOR);
		warnLabel.setImage(GUI.getDisplay().getSystemImage(SWT.ICON_WARNING));
		warnLabel.setLayoutData(gd);
		
		gd = new GridData(SWT.CENTER, SWT.CENTER, false, true);
		Label warnLabel1 = new Label(expandComp, SWT.NONE);
		warnLabel1.setBackground(GUI.BGCOLOR);
		warnLabel1.setFont(GUI.FONT_12_BOLD);
		warnLabel1.setLayoutData(gd);
		warnLabel1
				.setText("Following selected puck color coding of\nscreened crystals will be lost");
		
		Button[] puckButtons = new Button[ModelScreening.NoofPucks];
		for(int i=0;i<ModelScreening.NoofPucks;i++) {
			gd = new GridData(SWT.CENTER, SWT.FILL, false, true);
			gd.horizontalSpan = 2;
			puckButtons[i] = new Button(expandComp, SWT.CHECK);
			puckButtons[i].setBackground(GUI.BGCOLOR);
			puckButtons[i].setText("Puck "+ModelScreening.puckLabels[i]);
			puckButtons[i].setLayoutData(gd);
			puckButtons[i].setSelection(true);
			clearPucks[i] = true;
			final int ip = i;
			puckButtons[i].addSelectionListener(new SelectionListener() {

				@Override
				public void widgetDefaultSelected(SelectionEvent arg0) {}

				@Override
				public void widgetSelected(SelectionEvent arg0) {
						clearPucks[ip] = puckButtons[ip].getSelection();
				}	
			});
		}
		
		Composite buttonComp = new Composite(expandComp, SWT.BORDER);
		buttonComp.setBackground(GUI.BGCOLOR);
		GridLayout gl2 = new GridLayout(2, false);
		buttonComp.setLayout(gl2);
		gd = new GridData(SWT.FILL, SWT.FILL, true, true);
		gd.horizontalSpan = 2;
		buttonComp.setLayoutData(gd);
		buttonComp.setLayout(gl2);
		
		Button b1 = new Button(buttonComp, SWT.BORDER);
		b1.setText("Cancel");
		gd = new GridData(SWT.CENTER, SWT.FILL, true, true);
		gd.widthHint = 100;
		b1.setLayoutData(gd);
		b1.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}

			public void widgetSelected(SelectionEvent arg0) {
				buttonPressed = SWT.CANCEL;
				messageDialog.dispose();
			}
		});
		
		Button b2 = new Button(buttonComp, SWT.BORDER);
		b2.setText("Clear");
		gd = new GridData(SWT.CENTER, SWT.FILL, true, true);
		gd.widthHint = 100;
		b2.setLayoutData(gd);
		b2.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}

			public void widgetSelected(SelectionEvent arg0) {
				buttonPressed = SWT.OK;
				messageDialog.dispose();
			}
		});
		
		messageDialog.setDefaultButton(b1);
		messageDialog.pack();
		messageDialog.open();

		Display display = parent.getDisplay();
		while (!messageDialog.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		return buttonPressed;
	}

}
