/**
 * @author spothineni
 * 
 * color code is used for screening tasks status
 * 
 * This class is GUI for color code explanation, which is linked just below Start button
 */

package gov.anl.gmca.screening.ui;

import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;


public class WdgColorCodeExplanation extends Dialog {

	String Message = null;
	protected int buttonPressed = -1;
	protected Shell messageDialog = null;
	static StyledText styledText;

	public WdgColorCodeExplanation(Shell parent, int style, String message) {
		super(parent, style);

		Message = message;
	}

	public int open(int warning) {
		Shell parent = getParent();
		messageDialog = new Shell(parent, SWT.DIALOG_TRIM
				| SWT.APPLICATION_MODAL);
		messageDialog.setText("Screening tab Help");

		GridLayout gl = new GridLayout(2, false);
		gl.marginWidth = 10;
		gl.marginHeight = 10;
		gl.verticalSpacing = 10;
		messageDialog.setLayout(gl);

		Composite expandComp = new Composite(messageDialog, SWT.NONE);
		expandComp.setBackground(GUI.BGCOLOR);
		GridLayout gl1 = new GridLayout(2, false);
		expandComp.setLayout(gl1);
		GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true);
		expandComp.setLayoutData(gd);
		expandComp.setLayout(gl1);

		gd = new GridData();
		gd.widthHint = 550;
		gd.horizontalSpan = 2;
		Label greenRowLabel = new Label(expandComp, SWT.WRAP);
		greenRowLabel
				.setText("Green background on the spreadsheet is highlights the current mounted sample\n");
		greenRowLabel.setBackground(GUI.COLOR_THICK_GREEN);
		greenRowLabel.setSize(400, 30);
		greenRowLabel.setLayoutData(gd);

		gd = new GridData();
		gd.widthHint = 550;
		gd.horizontalSpan = 2;
		Label orangeRowLabel = new Label(expandComp, SWT.WRAP);
		orangeRowLabel
				.setText("Orange background on the spreadsheet is highlights the sample to be mounted next\n");
		orangeRowLabel.setBackground(GUI.COLOR_THICK_ORANGE);
		orangeRowLabel.setLayoutData(gd);

		gd = new GridData(SWT.LEFT, SWT.CENTER, false, false);

		Label greenLabel = new Label(expandComp, SWT.NONE);
		greenLabel.setBackground(GUI.BGCOLOR);
		greenLabel.setImage(GUI.imagegreen);
		greenLabel.setLayoutData(gd);

		gd = new GridData(SWT.FILL, SWT.CENTER, true, false);

		Label greenLabel1 = new Label(expandComp, SWT.NONE);
		greenLabel1.setBackground(GUI.BGCOLOR);
		greenLabel1
				.setText("represents sample was mounted properly and atleast 2 images were collected");
		greenLabel1.setLayoutData(gd);

		gd = new GridData(SWT.LEFT, SWT.CENTER, false, false);

		Label blueLabel = new Label(expandComp, SWT.NONE);
		blueLabel.setImage(GUI.imageblue);
		blueLabel.setBackground(GUI.BGCOLOR);
		blueLabel.setLayoutData(gd);

		gd = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd.grabExcessHorizontalSpace = true;
		Label blueLabel1 = new Label(expandComp, SWT.NONE);
		blueLabel1.setBackground(GUI.BGCOLOR);
		blueLabel1
				.setText("represents sample was mounted properly but less than 2 images were collected");
		blueLabel1.setLayoutData(gd);

		gd = new GridData(SWT.LEFT, SWT.CENTER, false, false);

		Label redLabel = new Label(expandComp, SWT.NONE);
		redLabel.setBackground(GUI.BGCOLOR);
		redLabel.setImage(GUI.imagered);
		redLabel.setLayoutData(gd);

		gd = new GridData(SWT.FILL, SWT.CENTER, true, false);

		Label redLabel1 = new Label(expandComp, SWT.NONE);
		redLabel1.setBackground(GUI.BGCOLOR);
		redLabel1
				.setText("represents robot failed to mount/unmount the sample");
		redLabel1.setLayoutData(gd);

		gd = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd.horizontalSpan = 2;
		Group scoreGroup = new Group(expandComp, SWT.NONE);
		scoreGroup.setBackground(GUI.BGCOLOR);
		scoreGroup.setFont(GUI.FONT_COLLECT_GROUP);
		GridLayout actionGrid = new GridLayout(2, false);
		scoreGroup.setLayout(actionGrid);
		scoreGroup.setText("Webice Crystal Score");
		scoreGroup.setLayoutData(gd);

		gd = new GridData(SWT.CENTER, SWT.CENTER, true, false);
		gd.horizontalSpan = 2;

		gd.horizontalAlignment = SWT.CENTER;
		Label scoreLabel2 = new Label(scoreGroup, SWT.NONE);
		scoreLabel2.setBackground(GUI.BGCOLOR);
		scoreLabel2.setImage(GUI.IMAGE_STRATEGYSCORE);
		scoreLabel2.setLayoutData(gd);

		gd = new GridData(SWT.LEFT, SWT.CENTER, false, false);
		gd.horizontalSpan = 2;
		gd.widthHint = 550;
		Label scoreLabel3 = new Label(scoreGroup, SWT.WRAP);
		scoreLabel3.setBackground(GUI.BGCOLOR);
		scoreLabel3
				.setText("where d is the resolution limit in \u212B, rmsd/rmsr (Root mean square deviation between the observed and predicted spots) is in mm, and \u03BC is the mosaicity in degrees. A score of 0.4-0.6 indicates borderline quality. Good crystals usually have a score of about 0.8 or higher. This score is meant to be used as an initial indicator of the sample quality; although it has been found to agree reasonably well with human assessment in many cases, it is recommended to inspect the diffraction before choosing a sample for data collection. ");
		scoreLabel3.setLayoutData(gd);

		Button b2 = new Button(expandComp, SWT.NONE);
		b2.setText("OK");
		gd = new GridData();
		gd.horizontalSpan = 2;
		gd.widthHint = 100;
		gd.grabExcessHorizontalSpace = true;
		gd.horizontalAlignment = SWT.CENTER;
		b2.setLayoutData(gd);
		b2.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}

			public void widgetSelected(SelectionEvent arg0) {
				buttonPressed = SWT.CANCEL;
				messageDialog.dispose();
			}
		});

		messageDialog.setDefaultButton(b2);
		messageDialog.pack();
		messageDialog.open();

		Display display = parent.getDisplay();
		while (!messageDialog.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		return buttonPressed;
	}

}
