package gov.anl.gmca.screening.ui;

import gov.anl.gmca.gui.MenuActions;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

// structure same as DlgDelete.java for raster
public class WdgDlgMessage extends Dialog {
	protected int buttonPressed = -1;
	protected Shell messageDialog = null;
	String Message = null;

	public WdgDlgMessage(Shell parent, int style, String message) {
		super(parent, style);
		Message = message;
	}

	// http://www.easywayserver.com/blog/java-how-to-remove-html-from-string/
	public static String removeHTML(String htmlString) {
		// Log.note("removing html tags");
		// Remove HTML tag from java String
		String noHTMLString = htmlString.replaceAll("\\<.*?\\>", "");

		// Remove Carriage return from java String
		noHTMLString = noHTMLString.replaceAll("\r", "<br/>");

		// Remove New line from java string and replace html break
		noHTMLString = noHTMLString.replaceAll("\n", " ");
		noHTMLString = noHTMLString.replaceAll("\'", "&#39;");
		noHTMLString = noHTMLString.replaceAll("\"", "&quot;");
		return noHTMLString;
	}

	public int open(int warning) {
		Shell parent = getParent();
		messageDialog = new Shell(parent, SWT.DIALOG_TRIM
				| SWT.APPLICATION_MODAL);
		messageDialog.setText("Message generated by Webice");

		// disable 'x' button in top right corner
		messageDialog.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event event) {
				event.doit = false;
			}
		});

		GridLayout gl = new GridLayout(1, false);
		gl.marginWidth = 10;
		gl.marginHeight = 10;
		gl.verticalSpacing = 10;
		messageDialog.setLayout(gl);
		GridData gd = null;

		Label lblIcon = new Label(messageDialog, SWT.NONE);
		lblIcon.setImage(Display.getDefault().getSystemImage(SWT.ICON_WARNING));
		gd = new GridData();
		lblIcon.setLayoutData(gd);

		Label lbl = new Label(messageDialog, SWT.NONE);
		if (warning == 0)
			lbl.setText("Loaded spreadsheet has issues, Auto-changes have been made: \nChanged spreadsheet will be loaded, Please check and reload if necessary ");
		else
			lbl.setText("Spreadsheet is not loaded, Please correct the errors below \n and reload the spreadsheet.");

		Link link = new Link(messageDialog, SWT.BORDER);
		link.setText("See Instructions <a>http://www.gmca.anl.gov/facilities/automounter.html#instructions</a><a href=\"http://www.gmca.anl.gov/facilities/automounter.html#instructions\">");
		link.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				MenuActions.openSpreadsheetInstructions();
			}
		});
		gd = new GridData();
		gd.horizontalAlignment = SWT.LEFT;
		lbl.setLayoutData(gd);

		StyledText text = new StyledText(messageDialog, SWT.V_SCROLL
				| SWT.H_SCROLL | SWT.WRAP);
		gd = new GridData();
		gd.horizontalSpan = 2;
		gd.horizontalAlignment = SWT.FILL;
		gd.grabExcessHorizontalSpace = true;
		gd.widthHint = 300;
		gd.heightHint = 500;
		text.setLayoutData(gd);
		// Log.note(Message);
		if (Message != null || Message != "") {
			if (Message.substring(0, 6).equals("<html>")
					|| Message.substring(0, 6).equals("<HTML>"))
				text.setText(removeHTML(Message));
			else
				text.setText(Message);
		}
		Composite buttonComp = new Composite(messageDialog, SWT.NONE);
		gd = new GridData();
		gd.horizontalSpan = 2;
		gd.grabExcessHorizontalSpace = true;
		gd.horizontalAlignment = SWT.FILL;
		buttonComp.setLayoutData(gd);
		buttonComp.setLayout(new GridLayout(2, false));

		Button b2 = new Button(buttonComp, SWT.NONE);
		b2.setText("OK");
		gd = new GridData();
		gd.grabExcessHorizontalSpace = true;
		gd.horizontalAlignment = SWT.FILL;
		b2.setLayoutData(gd);
		b2.addSelectionListener(new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}

			public void widgetSelected(SelectionEvent arg0) {
				buttonPressed = SWT.CANCEL;
				messageDialog.dispose();
			}
		});

		messageDialog.setDefaultButton(b2);

		messageDialog.pack();
		messageDialog.open();

		Display display = parent.getDisplay();
		while (!messageDialog.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		return buttonPressed;
	}
}
