/**
 * @author spothineni
 * 
 * mini popout for Sample status
 */

package gov.anl.gmca.screening.ui;

import gov.anl.gmca.gui.GUI;
import gov.anl.gmca.io.Epics;
import gov.anl.gmca.io.PVLookup.PV_ROBOT;
import gov.anl.gmca.io.PVLookup.PV_SCR;
import gov.anl.gmca.users.ModelUserTable.ClientListener;
import gov.aps.jca.dbr.DBR;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

public class WdgSampleInfoPeelOut implements ClientListener {

	protected Shell parent = null;
	public Shell messageDialog = null;
	public String Message = null;
	public Label labelMounted, gScreeningStatus, wTime;

	GridData gd = null;
	Epics.EpicsValueMonitor monitor = null;

	public WdgSampleInfoPeelOut(Shell _parent, int style) {
		parent = _parent;
	}

	public void create() {
		messageDialog = new Shell(parent, SWT.DIALOG_TRIM);
		messageDialog.setText("Mini Screening Control");

		GridLayout gl = new GridLayout(2, false);
		gl.marginWidth = 10;
		gl.marginHeight = 10;
		gl.verticalSpacing = 10;
		messageDialog.setLayout(gl);

		gd = new GridData(SWT.CENTER, SWT.CENTER, true, true);
		gd.minimumHeight = 130;
		gd.minimumWidth = 350;

		final Label labelMounted = new Label(messageDialog, SWT.NONE);
		labelMounted.setFont(GUI.FONT_SCRRENING_SAMPLE_110);
		labelMounted.setForeground(GUI.COLOR_BLUE);
		labelMounted.setAlignment(SWT.CENTER);
		labelMounted.setText("D14"); // fake to get enough space

		String mounted = Epics.getString(PV_ROBOT.mounted);
		if (mounted.equals("none")) {
			labelMounted.setText(mounted);
			labelMounted.setFont(GUI.FONT_SCRRENING_SAMPLE_110);
		}

		labelMounted.setText(mounted);
		labelMounted.setLayoutData(gd);

		new WdgRobotStatus(messageDialog, SWT.NONE);

		gd = new GridData();
		gd.horizontalAlignment = SWT.FILL;
		gd.grabExcessHorizontalSpace = true;
		gd.verticalAlignment = GridData.FILL;

		gScreeningStatus = new Label(messageDialog, SWT.NONE);
		gScreeningStatus.setFont(GUI.FONT_COLLECT_BUTTON2);
		gScreeningStatus.setAlignment(SWT.CENTER);
		gScreeningStatus.setForeground(GUI.COLOR_BLUE);
		gScreeningStatus.setBackground(GUI.BGCOLOR);
		gScreeningStatus.setLayoutData(gd);

		new WdgScreeningButtons(messageDialog, SWT.NONE);

		gd = new GridData();
		gd.horizontalAlignment = SWT.CENTER;
		gd.grabExcessHorizontalSpace = true;
		gd.verticalAlignment = GridData.FILL;
		messageDialog.setLayoutData(gd);

		messageDialog.pack();
		messageDialog.addShellListener(new ShellAdapter() {
			public void shellClosed(ShellEvent e) {
				e.doit = false;
				GUI.asyncExec(new Runnable() {
					public void run() {
						// TabSample.
						messageDialog.setVisible(false);
					}
				});
			}
		});

		// TODO: (optional) this object can be broken up in to individual
		// monitors for each PV specified below -MH
		monitor = new Epics.EpicsValueMonitor() {
			@Override
			public void valueChanged(String pvName, DBR value) {
				final String _pvName = pvName;
				final DBR _value = value;

				if (_pvName.equals(PV_ROBOT.mounted.toString())) {

					final String mounted = Epics.dbrToString(_value);
					GUI.asyncExec(new Runnable() {
						public void run() {
							if (mounted.equals("none"))
								labelMounted
										.setFont(GUI.FONT_SCRRENING_SAMPLE_80);
							else
								labelMounted
										.setFont(GUI.FONT_SCRRENING_SAMPLE_110);
							labelMounted.setText(mounted);

							messageDialog.layout(true, true);
						}
					});
				}
				if (_pvName.equals(PV_SCR.CurrentTask.toString())) {
					GUI.asyncExec(new Runnable() {
						public void run() {
							gScreeningStatus.setText(Epics.dbrToString(_value));
						}
					});
				}
			}
		};

		Epics.addMonitor(PV_ROBOT.mounted, monitor);
		Epics.addMonitor(PV_SCR.CurrentTask, monitor);
	}

	@Override
	public void masterChanged(boolean isMaster) {
		// TODO Auto-generated method stub

	}

}
