package gov.anl.gmca.server.messaging;

import java.util.ArrayList;
import java.util.HashMap;

public class MessageQueue
{
    private static HashMap<String, ArrayList<String>> queues = new HashMap<>();

    public static boolean syncSend(String clientID, String message, int timeoutMs)
    {
        send(clientID, message);
        while (true)
        {
            return true;
        }
    }

    public static void send(String clientID, String message)
    {
        synchronized(queues)
        {
            if (!queues.containsKey(clientID))
            {
                queues.put(clientID, new ArrayList<String>());
            }
            queues.get(clientID).add(message);
        }
    }

    public static ArrayList<String> get(String clientID)
    {
        synchronized(queues)
        {
            if (!queues.containsKey(clientID)) return new ArrayList<>();
            ArrayList<String> ret = queues.get(clientID);
            queues.remove(clientID);
            return ret;
        }
    }
}
