package gov.anl.gmca.spotfinder;

import gov.anl.gmca.collect.DevFPE;
import gov.anl.gmca.spotfinder.DevSFType.SFRunType;
import gov.anl.gmca.spotfinder.DevSFType.SPOTFINDER_TYPE;

import java.util.ArrayList;
import java.util.List;

public class CmdSFTest implements Runnable
{
	private SFRunType sfRunType;
	private DlgSFTest dlg;
	public void start() { new Thread(this).start(); }
	public CmdSFTest(SFRunType sfRunType) { this.sfRunType=sfRunType; }

	@Override public void run()
	{
		String fullDir = DevFPE.get().getImageViewerFile().directory;
		String filename = DevFPE.get().getImageViewerFile().filename;
		String prefix = "A1";
		int runLabel = 1;
		double resMin=50,resMax=.1;

		String sfName = DevSFType.getConfig(sfRunType).name;
		if (null==dlg) {
			dlg = new DlgSFTest(sfName + ": " + filename, this);
			dlg.asyncOpen();
		}

		CmdSpotFinderRemote cmdProcess = new CmdSpotFinderRemote
		(
			null,
			sfRunType,
			-1,
			-1,
			fullDir,
			new ArrayList<>(List.of(filename)),
			prefix,
			runLabel,
			resMin,
			resMax,
			0,
			DevSFType.get(sfRunType)._getConfig().id,
			null,
			CmdSpotFinder.TIMEOUT_DEFAULT_MS
		);
		dlg.addText("Loading: "+String.join(" ",cmdProcess.cmd)+"\n\n");
		cmdProcess.run();

		if (cmdProcess.sfFailed) {
			dlg.addText(cmdProcess.errMsg + "\n");
		}
		for (String s : cmdProcess.cmdOutput) {
			dlg.addText(s+"\n");
		}
	}
}
