package gov.anl.gmca.spotfinder;

import gov.anl.gmca.common.ui.NBDialog;
import gov.anl.gmca.gui.GUI;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

public class DlgSFTest extends NBDialog
{
    protected Text text;
    private CmdSFTest cmd;

    public DlgSFTest(String title, CmdSFTest cmd)
    {
        super(GUI.getShell(), SWT.APPLICATION_MODAL|SWT.DIALOG_TRIM);
        setText(title);
        this.cmd=cmd;
        shellStyle = SWT.SHELL_TRIM;
    }

    @Override protected void createContents(Composite parent)
    {
        parent.setLayout(new GridLayout(3,false));

        text = new Text(parent, SWT.MULTI | SWT.V_SCROLL | SWT.READ_ONLY | SWT.WRAP);
        text.setFont(GUI.FONT_12_FIXED);
        GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true, 3, 1);
        gd.widthHint = 600;
        gd.heightHint = 400;
        text.setLayoutData(gd);

        Composite filler = new Composite(parent, SWT.NONE);
        gd = new GridData(GridData.FILL_HORIZONTAL);
        gd.heightHint=1;
        filler.setLayoutData(gd);

        Button retestButton = new Button(parent,SWT.NONE);
        retestButton.setText("Retest");
        gd = new GridData(SWT.RIGHT, SWT.DEFAULT, false, false);
        gd.widthHint = 60;
        retestButton.setLayoutData(gd);
        retestButton.addSelectionListener(new SelectionListener()
        {
            public void widgetDefaultSelected(SelectionEvent arg0) {}
            public void widgetSelected(SelectionEvent arg0)
            {
                text.setText("");
                cmd.start();
            }
        });

        Button okButton = new Button(parent,SWT.NONE);
        okButton.setText("OK");
        gd = new GridData(SWT.RIGHT, SWT.DEFAULT, false, false);
        gd.widthHint = 60;
        okButton.setLayoutData(gd);
        okButton.addSelectionListener(new SelectionListener()
        {
            public void widgetDefaultSelected(SelectionEvent arg0) {}
            public void widgetSelected(SelectionEvent arg0)
            {
                closeDialog();
            }
        });

        dialogShell.setDefaultButton(okButton);
    }

    public void addText(String textToAdd)
    {
        GUI.asyncExec(()-> {
            if (!text.isDisposed()) {
                text.append(textToAdd);
                System.out.println("DlgSFTest: " + text);
            }
        });
    }
}
