package gov.anl.gmca.spotfinder;

import gov.anl.gmca.common.SQLDataType;
import gov.anl.gmca.io.Database.DBField;
import gov.anl.gmca.spotfinder.DevSFType.SPOTFINDER_OUTPUT;

import java.util.HashMap;

public class SFData
{
	public static enum SFDBField
	{
		SF_TYPE			(new DBField("sfType", 				SQLDataType.ENUM_RUN_TYPE, false, true, null)),
		RUN_INDEX		(new DBField("runIndex", 			SQLDataType.INT, false, true, null)),
		FRAME_INDEX		(new DBField("frameIndex", 			SQLDataType.INT, false, true, null)),
		STATE			(new DBField("state", 				SQLDataType.ENUM_PROCESS_STATE, false, false, null)),
		SF_RESULTS1		(new DBField("sf_results1",			SQLDataType.VARCHAR, true, false, null)),
		SF_RESULTS2		(new DBField("sf_results2",			SQLDataType.VARCHAR, true, false, null)),
		SF_RESULTS3		(new DBField("sf_results3",			SQLDataType.VARCHAR, true, false, null)),
		SF_RESULTS4		(new DBField("sf_results4",			SQLDataType.VARCHAR, true, false, null)),
		SF_RESULTS5		(new DBField("sf_results5",			SQLDataType.VARCHAR, true, false, null));

		public static final int MAX_RESULTS = 10;
		public static String resultName(int index) { return "sf_results"+(index+1); }
		
		public DBField getDBF() { return dbField; }
		@Override public String toString() { return dbField.fieldName; }
		
		DBField dbField;
		private SFDBField(DBField dbField) { this.dbField=dbField; }
	}

	public static enum SFType
	{
		COLLECT, INTER_RASTER, AUTO_RASTER;
	}

	public static class SFImageData
	{
		public SFData.State state;
		public int frameIndex;
		public double flValue, soniccValue;
		public HashMap<SPOTFINDER_OUTPUT,Double> values = new HashMap<>();
	}

	public enum State
	{
		CLEAR, DONE, ERROR;
		
		public static State stringToState(String s)
		{
			for (State state : State.values())
			{
				if (state.toString().toLowerCase().equals(s.toLowerCase())) return state;
			}
			return null;
		}
	}

}
