package gov.anl.gmca.spotfinder;

import com.github.wnameless.json.flattener.FlattenMode;
import com.github.wnameless.json.flattener.JsonFlattener;
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;
import gov.anl.gmca.util.*;

import java.util.*;


public class TestSFParser
{
    @org.junit.Test
    public void testParser()
    {
        try {
            String url = "http://10.20.103.215:8129/dozor_mp/dozor_mp.py?file_name=/mnt/beegfs/testdata/PC/PC_000117.cbf&spots=1";
            HttpResponse<String> resp = Unirest.get(url).asString();
            if (resp.getStatus()!=200) {
                Util.printf("ERROR: Got code %d from URL %s", resp.getStatus(), url);
                return;
            }
            String json = resp.getBody();
            Map<String,Object> flatMap = new JsonFlattener(json).withFlattenMode(FlattenMode.KEEP_ARRAYS).flattenAsMap();
            int spotTotal = Integer.parseInt((String)flatMap.get("num_peaks"));
            double res = Double.parseDouble((String)flatMap.get("Resolution Wilson"));
            double mainScore = Double.parseDouble((String)flatMap.get("Main Score"));
        } catch (Exception e) { e.printStackTrace(); }
    }
}
