package gov.anl.gmca.syslog;

import gov.anl.gmca.gui.GUIStatus;
import gov.anl.gmca.gui.WdgMain;

public class Log
{
	public static final int STYLE_NOTE 		= 0;
	public static final int STYLE_WARNING 	= 1;
	public static final int STYLE_ERROR 	= 2;
	
	protected static final String[] prefixes = 
	{
		"NOTE: ",
		"WARNING: ",
		"ERROR: "
	};
	
	protected static void println(String s, int style)
	{
		System.out.println(prefixes[style]+s);
		
		// TODO: reduce the number of checks here to one to improve performance
		if (GUIStatus.inGUIMode && null != WdgMain.get() && null != WdgMain.get().getLogWidget())
		{
			WdgMain.get().getLogWidget().println(prefixes[style]+s,style);
		}
	}

	public static void note(String s) 	{ println(s,STYLE_NOTE); 	}
	public static void warn(String s) 	{ println(s,STYLE_WARNING); }
	public static void error(String s) 	{ println(s,STYLE_ERROR); 	}
	public static void ui(String s)		{ System.out.println("USER_INPUT: "+s); }
}
