package gov.anl.gmca.util;

import gov.anl.gmca.syslog.Log;

public class ActionResult
{
	public static ActionResult SUCCESS = new ActionResult(true);
	public static ActionResult FAILURE = new ActionResult(false);
	
	protected String error;
	protected boolean success;
	
	public String getError() { return error; }
	public boolean succeeded() { return success; }
	
	protected ActionResult(boolean success)
	{
		this.success = success;
		error = null;
	}
	
	public ActionResult(String error)
	{
		this.success = false;
		this.error = error;
	}

	public ActionResult(String error, boolean printError)
	{
		this.success = false;
		this.error = error;
		
		if (printError) Log.error(error);
	}
}
