package gov.anl.gmca.util;

import java.util.ArrayList;

public class ListenerList<T>
{
	protected T object;
	public ListenerList(T object) { this.object = object; }
	
	public static interface Listener<T>
	{
		public void handleEvent(T object, Object data);
	}

	public ArrayList<Listener<T>> list = new ArrayList<Listener<T>>();
	public void addListener(Listener<T> listener) { list.add(listener); }
	public void removeListener(Listener<T> listener) { while (list.contains(listener)) list.remove(listener); }
	public void notifyListeners() { for (Listener<T> l : new ArrayList<Listener<T>>(list)) l.handleEvent(object, null); }
	public void notifyListeners(Object data) { for (Listener<T> l : new ArrayList<Listener<T>>(list)) l.handleEvent(object, data); }
}
