package gov.anl.gmca.util;

import gov.anl.gmca.io.ExecTask;
import gov.anl.gmca.syslog.Log;

import java.io.File;
import java.io.FilenameFilter;

public class SpreadsheetViewer
{
	private static String viewerPath = null;
	private static final String binDir = "/usr/bin";
	
	private static void findViewerPath()
	{
		File dir = new File(binDir);
		File[] listing = dir.listFiles(new FilenameFilter()
		{
			@Override public boolean accept(File dir, String name)
			{
				return name.indexOf("libreoffice")==0;
			}
		});
		if (listing.length==0)
			Log.error("Couldn't find LibreOffice binary");
		else
			viewerPath = listing[0].getAbsolutePath();
	}
	
	public static void openSpreadsheet(String path)
	{
		if (null==viewerPath) findViewerPath();
		ExecTask.asyncExec(viewerPath+" --calc "+path, "LibreOffice", false);
	}
}
