import gov.anl.gmca.io.ExecTask;
import gov.anl.gmca.sample.DBBeamSize;
import gov.anl.gmca.sample.DBBeamSize.BeamSize;
import gov.anl.gmca.util.Util;

public class TestDBBeamSize
{
    @org.junit.Test
    public void testDBBeamSize()
    {
        try {
            Class.forName("com.mysql.jdbc.Driver").getConstructor().newInstance();
            DBBeamSize.init();
        } catch (Exception e) { e.printStackTrace(); return; }

        int[] colli_sizes = new int[]{5,10,20,100};

        String inputText = "";

        for (int colli : colli_sizes) {
            inputText += colli + "um ";
            for (double e = 10.0; e < 14.0; e += 0.1) {
                BeamSize bs = DBBeamSize.getBeamSize(colli, e);
                inputText += Util.sprintf("%.2f %.2f %.2f ", e, bs.width_um, bs.height_um);
            }
            inputText += "\n";
        }
        System.out.println(inputText);

        String bluice_dir = "/mnt/beegfs/mhilgart/PycharmProjects/bluice";
        String cmd = Util.sprintf("python %s/src/tools/beam_size_plot.py", bluice_dir);
        ExecTask task = ExecTask.new_ExecTask(cmd, "beam_size_plot",true,false);
        task.inputText = inputText;
        task.start();
        task.waitFor();
    }
}
