import gov.anl.gmca.common.*;
import gov.anl.gmca.io.*;
import gov.anl.gmca.sample.*;
import gov.anl.gmca.server.*;
import gov.anl.gmca.util.*;
import redis.clients.jedis.*;

import static gov.anl.gmca.server.DeviceInit.*;

public class TestSONICC
{
    @org.junit.Test
    public void testSONICC()
    {
        SimBeamline.start();
        Epics.connect();
        initMotors();
        initMotorAssemblies();
        DevSlider.init();
        new DevDataDir();

        for (int i=0;i<3;i++) {
            System.out.println("Waiting for devices to connect...");
            Util.sleep(1000);
        }
        System.out.println("Starting test");

        try (Jedis jedis = Redis.get()) {
            jedis.hset(Redis.sonicc_state, "rel_dir", ".");
            jedis.hset(Redis.sonicc_state, "prefix", "test");
            jedis.hset(Redis.sonicc_state, "mode", "SHG");
            jedis.hset(Redis.sonicc_state, "slice_count", "1");
            jedis.hset(Redis.sonicc_state, "slice_width_um", "20");
         }

        //CmdSONICCAcquire.start();
       // CmdSONICCAcquire.waitFor();
    }
}
