import platform
import pepper.libpepper


def get_beamline_index():
    name = platform.node()
    if name[:2] != "bl":
        raise Exception("Unrecognized host name: "+name)
    return int(name[2:3])-1


def get_jbluice_server_host():
    return ('bl1ws3', 'bl2ws3', 'bl3ws3')[get_beamline_index()]


def get_streamwriter_host():
    return (None, 'bl2epu', None)[get_beamline_index()]


def get_salt_passwd():
    with open('/etc/salt/salt.pwd') as f:
        return f.readline().strip()


# salt config
saltMasterURL = 'https://10.20.103.133:8000/'
saltUsername = 'salt'
saltAuth = 'pam'
saltPasswd = get_salt_passwd()
jbsHost = get_jbluice_server_host()
swHost = get_streamwriter_host()


def salt_cmd(tgt, fun, arg):
    pepper_conn = pepper.libpepper.Pepper(saltMasterURL)
    pepper_conn.login(saltUsername, saltPasswd, saltAuth)
    r = pepper_conn.low([{
        'client': 'local',
        'tgt': tgt,
        'fun': fun,
        'arg': arg
    }])
    return r['return'][0][tgt]
