#!/bin/csh
#
# Running XDS in parallel, works only on 23ID beamlines @APS
#
# Usage : procXDS.csh <file_prefix>
#
# Ver 1 : Sudhir Babu Pothineni, 
# GM/CA CAT, APS, Argonne National Laboratory
# Ver 2 : runs fast_dp 09/10/2012
#
# running XDS in parallel
echo "Processing XDS"
set prefix = $1
/mnt/software/px/XDS/xds_par >& GMCAproc.LOG
set scriptDir = `dirname $0`

if( -e GMCAproc.LOG) then
	# check if XDS has error about insufficient percentage of spots
	set xds_error = (`cat GMCAproc.LOG | awk '/INSUFFICIENT PERCENTAGE/{ print $0; }'`)

	if ( "$xds_error" != "") then 
		echo "Error INSUFFICIENT PERCENTAGE rerunning XDS with DEFPIX INTEGRATE CORRECT"
		cp -rp ../XDS ../XDS_FAILED
		sed "s/JOB\= /\!JOB=  /g" XDS.INP > XDS1.INP
		#sed "s/\!JOB\= DEFPIX INTEGRATE CORRECT/JOB= DEFPIX INTEGRATE CORRECT/g" XDS1.INP > XDS.INP
		echo "JOB= DEFPIX INTEGRATE CORRECT" >> XDS1.INP
		mv XDS1.INP XDS.INP
		echo "Rerunning XDS with only JOB= DEFPIX INTEGRATE CORRECT"
		/mnt/software/px/XDS/xds_par >& GMCAproc.LOG
	endif
endif

#exit upon XDS error don't scale
#set xds_error = (`cat GMCAproc.LOG | awk '/!!! ERROR /{ print $0; }'`)

#if ( "$xds_error" == "") then
#	exit
#endif
