#!/mnt/beegfs/mhilgart/anaconda3/bin/python

# h5clean.py
# 
# Deletes unneeded header information to reduce the master file size.
# Currently just for testing, not intended for users.
#
# Uses the anaconda python environment for now.  I'm not sure how we'll
# end up deploying it.
#
# Usage: ./h5clean.py A1_1_master.h5
#
# -MH

import h5py
import sys
import os

ds='/entry/instrument/detector/detectorSpecific/'

# open the master file
with h5py.File(sys.argv[1],'a') as f:

    # delete the whole-detector arrays
    for arrayName in ['flatfield']:
        fullName=ds+arrayName
        if fullName in f:
            del f[fullName]

    # for each of the 64 modules
    for moduleIndex in range(0,63):
        moduleName=ds+'detectorModule_%03d'%moduleIndex+'/'

	# delete the per-module arrays
        for arrayName in ['flatfield','pixel_mask','trimbit','countrate_correction_table']:
            fullName=moduleName+arrayName
            if fullName in f:
                del f[fullName]

# repacking is needed, otherwise free space is not recovered
os.system("h5repack "+sys.argv[1]+" "+sys.argv[1]+"_temp")

# overwrite the original master file with the repacked one
os.system("mv -f "+sys.argv[1]+"_temp "+sys.argv[1])

