#!/bin/csh
#
# Running Scaling in parallel, works only on 23ID beamlines @APS
#
#
# Usage : scale.csh <file_prefix> 
#
# Ver 1 : Sudhir Babu Pothineni, 
# GM/CA CAT, APS, Argonne National Laboratory
#
# proceed to scaling if XDS_ASCII.HKL available

#source ccp4 environment
source /mnt/software/px/cshrc_px

set dir = $1
set scale = $2
set prefix = $3
set scriptDir = `dirname $0`

cd $dir

mkdir POINTLESS_AIMLESS
cd POINTLESS_AIMLESS
echo $dir/POINTLESS_AIMLESS
ln -s ../XSCALE/XDS_ASCII.AHKL XDS_ASCII.HKL
echo "Transforming output to mtz with POINTLESS"
echo "pointless -c XDSIN ../XSCALE/XDS_ASCII.AHKL HKLOUT ${prefix}_xds.mtz <<EOF > ${prefix}_pointless.log" > pointless.sh 
echo "END" >> pointless.sh
echo "EOF" >> pointless.sh

chmod +x pointless.sh
source pointless.sh


echo
echo "Scaling and merging data with $scale"

echo "$scale hklin ${prefix}_xds.mtz hklout ${prefix}_$scale.mtz \\" > $scale.sh
echo " <<EOF> ${prefix}_$scale.log" >> $scale.sh
echo "run 1 all" >> $scale.sh
echo "scales constant" >> $scale.sh
echo "anomalous on" >> $scale.sh
echo "cycles 0" >> $scale.sh
#echo "sdcorrection noadjust norefine both 1.0 0.0 0.0" >> $scale.sh
echo "END" >> $scale.sh
echo "EOF" >> $scale.sh

chmod +x $scale.sh
source $scale.sh 

cp -p ${prefix}_$scale.log $scale.log

echo "$scale finished. See ${prefix}_$scale.log"

mkdir ../.JBluIce
mv ../*.o* ../*.e* ../.JBluIce

echo `date`
exit
