import os


def template_to_filename(atemplate, number):
    if isinstance(number, str):
        number = int(number)

    sep = "?"
    atemplate.replace("#", "?")
    ndigits = atemplate.count(sep)

    num = "{:0{}d}".format(number, ndigits)
    filename = atemplate.replace(sep * ndigits, num)
    return filename


def validate_entry(atemplate, nstart, nend):
    # check the files are actually exist
    image_nums = [i for i in range(nstart, nend + 1) if os.path.exists(template_to_filename(atemplate, i))]
    if len(image_nums) >= 1:
        return [atemplate, image_nums[0], image_nums[-1]]
    else:
        return None


def find_datasets_from_template_file(list_of_datasets):
    datasets = []
    if os.path.exists(list_of_datasets):
        with open(list_of_datasets) as f:
            lines = f.readlines()

        # remove duplicates
        new_lines = []
        for l in lines:
            if l not in new_lines:
                new_lines.append(l)

        candidates = [c for c in [l.rstrip().split(",") for l in new_lines] if len(c) == 3]
        for c in candidates:
            template, start, end = c
            if int(start) == int(end) == 0:
                continue

            validated_sweep = validate_entry(template, int(start), int(end))
            if validated_sweep:
                datasets.append(validated_sweep)

    return datasets
