from __future__ import absolute_import
from ..process.get_args import ARGS
import logging
import subprocess

PV_STRATEGY_LASTXTAL = None
PV_STRATEGY_JOBSTATUS = None
PV_ANALYSIS_PIPELINESTATUS = None

if ARGS.beamline:
    PV_STRATEGY_LASTXTAL = "{}:bi:strategy:strategyLastXtal".format(ARGS.beamline)
    PV_STRATEGY_JOBSTATUS = "{}:bi:strategy:strategyJobStatus".format(ARGS.beamline)
    PV_ANALYSIS_PIPELINESTATUS = "{}:bi:analysis:pipelineStatus".format(ARGS.beamline)


def caput(pvname, value):
    if pvname == PV_STRATEGY_JOBSTATUS:
        ret = subprocess.run(['/usr/local/epics/base/bin/linux-x86_64/caput', '-S', pvname, '{}'.format(value)], stdout=subprocess.DEVNULL)
    else:
        ret = subprocess.run(['/usr/local/epics/base/bin/linux-x86_64/caput', pvname, '{}'.format(value)], stdout=subprocess.DEVNULL)

    if ret.returncode == 0:
        logging.info("update PV {} with: {}.".format(pvname, value))
    else:
        logging.info("failed to update PV {} with: {}.".format(pvname, value))


def update_PV(pvname, value, force_update=True, wait=True, timeout=30):
    if not pvname:
        return

    if force_update:
        caput(pvname, "")

    caput(pvname, value)


def update_strategy_ready_PV():
    if ARGS.prefix:
        update_PV(PV_STRATEGY_LASTXTAL, ARGS.prefix)
    elif ARGS.sampleName:
        update_PV(PV_STRATEGY_LASTXTAL, ARGS.sampleName)


def update_strategy_job_status_PV(status):
    update_PV(PV_STRATEGY_JOBSTATUS, status, force_update=False)


def update_pipelineStatus_PV(id, pipeline, state):
    value = "{} {} {}".format(id, pipeline, state)
    update_PV(PV_ANALYSIS_PIPELINESTATUS, value, force_update=False)
