import glob
import multiprocessing
import os
import threading
import time


# monitor histlist
class HitlistMonitor:
    def __init__(self, queue, directory=None):
        self.directory = directory
        self.task_queue = queue
        self.hitlists = set()

    def monitor(self):
        while True:
            if os.path.exists(self.directory):
                hitlist_files = glob.glob("{}/hit*".format(self.directory))
                for hitlist_file in hitlist_files:
                    if hitlist_file not in self.hitlists:
                        with open(hitlist_file, 'r') as fh:
                            lines = fh.readlines()
                        for line in lines:
                            image_file = line.split()[0]
                            if os.path.exists(image_file):
                                self.task_queue.put(image_file)
                        self.hitlists.add(hitlist_file)
            time.sleep(1)


if __name__ == "__main__":
    q = multiprocessing.Queue()
    dirx = "/mnt/beegfs/qxu"
    mon = HitlistMonitor(q, dirx)
    t = threading.Thread(target=mon.monitor)
    t.daemon = True
    t.start()
    while True:
        time.sleep(1000)
    print("done")
