
import random
import time, sys, math
from multiprocessing import Process, Queue, Pool, Manager

outq = Queue()

class DummyProducer:
    def __init__(self, outq):

        self.outq = outq
        self.process = Process(target=self.produce)
        self.process.start()

    def produce(self):
        count = 0
        while True:
            x = random.randint(1, 1000)
            y = random.random()
            count += 1
            self.outq.put({x: y})
            print("= generated ", count)

            time.sleep(random.randint(1, 5))

    def stop(self):
        if self.process.is_alive():
            self.process.terminate()

    def get_queue(self):
        return self.outq


from  multiprocessing import Pool
from os import getpid
from time import sleep
from random import random

MAX_WORKERS=5

class TestingMpApplyAsync(object):
    def __init__(self, queue):
        """
        Initiates a pool of processes.
        """
        self.pool = Pool(processes=MAX_WORKERS,)
        self.queue = queue

        self.proc = Process(target=self.generate_some_work())
        self.proc.start()

    def generate_some_work(self):
        """
        This method writes some messages to the queue.
        """
        for i in range(50):
            self.pool.apply_async(worker_main, args=(self.queue, "First item for loop {}".format(i),))
            self.pool.apply_async(worker_main, [self.queue, "2nd item for loop {}".format(i)])

def worker_main(queue, msg):
    """
    This function will be executed by a subprocess of the pool.
    It can't be integrated to a class because you can't pass a method of
    an object instance to apply_async(), you need to use a function.
    """
    print("{0} retrieved: {1}".format(getpid(), msg))
    # simulate some random length operations
    queue.put(msg)
    sleep(random())

# Warning from Python documentation:
# Functionality within this package requires that the __main__ module be
# importable by the children. This means that some examples, such as the
# multiprocessing.Pool examples will not work in the interactive interpreter.
if __name__ == '__main__':
    qm = Manager()
    queue = qm.Queue()
    mp_class = TestingMpApplyAsync(queue)
    #mp_class.generate_some_work()
    # Waits a bit for the child processes to do some work
    # because when the parent exits, childs are terminated.
    sleep(10)
    print(queue.qsize())