

sge_template = """\
#!/bin/sh
#$ -cwd
#$ -j y
#$ -V
#$ -S /bin/bash
#$ -o {joblabel}.out
##$ -e {joblabel}.err


echo job started at `date "+%Y-%m-%d %H:%M:%S"`
echo "host: `hostname -s` (`uname`) user: `whoami`"
echo
echo


export LC_ALL="en_US.UTF-8"

{chdir}
{script_text}

echo
echo
echo job finished at `date "+%Y-%m-%d %H:%M:%S"`
"""

slurm_template = """\
#!/bin/sh

#SBATCH --export=ALL
#SBATCH -o {joblabel}.out
##SBATCH -e {joblabel}.err


echo job started at `date "+%Y-%m-%d %H:%M:%S"`
echo "host: `hostname -s` (`uname`) user: `whoami`"
echo
echo

export LC_ALL="en_US.UTF-8"

{chdir}
{script_text}

echo
echo
echo job finished at `date "+%Y-%m-%d %H:%M:%S"`
"""


def get_template(runner='slurm'):
    if 'sge' in runner:
        return sge_template
    else:
        return slurm_template

