MASK_PILATUS_6M = '''
UNTRUSTED_RECTANGLE= 487  495     0 2528
UNTRUSTED_RECTANGLE= 981  989     0 2528
UNTRUSTED_RECTANGLE=1475 1483     0 2528
UNTRUSTED_RECTANGLE=1969 1977     0 2528
UNTRUSTED_RECTANGLE=   0 2464   195  213
UNTRUSTED_RECTANGLE=   0 2464   407  425
UNTRUSTED_RECTANGLE=   0 2464   619  637
UNTRUSTED_RECTANGLE=   0 2464   831  849
UNTRUSTED_RECTANGLE=   0 2464  1043 1061
UNTRUSTED_RECTANGLE=   0 2464  1255 1273
UNTRUSTED_RECTANGLE=   0 2464  1467 1485
UNTRUSTED_RECTANGLE=   0 2464  1679 1697
UNTRUSTED_RECTANGLE=   0 2464  1891 1909
UNTRUSTED_RECTANGLE=   0 2464  2103 2121
UNTRUSTED_RECTANGLE=   0 2464  2315 2333
'''

MASK_EIGER_16M = '''
!* EXCLUSION OF HORIZONTAL DEAD AREAS OF THE EIGER 16M DETECTOR + ONE PIXEL ON EACH SIDE
UNTRUSTED_RECTANGLE=    0 4150    513  553
UNTRUSTED_RECTANGLE=    0 4150   1064 1104
UNTRUSTED_RECTANGLE=    0 4150   1615 1655
UNTRUSTED_RECTANGLE=    0 4150   2166 2206
UNTRUSTED_RECTANGLE=    0 4150   2717 2757
UNTRUSTED_RECTANGLE=    0 4150   3268 3308
UNTRUSTED_RECTANGLE=    0 4150   3819 3859
!* EXCLUSION OF VERTICAL DEAD AREAS OF THE EIGER 16M DETECTOR + ONE PIXEL ON EACH SIDE
UNTRUSTED_RECTANGLE= 1029 1042      0 4371
UNTRUSTED_RECTANGLE= 2069 2082      0 4371
UNTRUSTED_RECTANGLE= 3109 3122      0 4371
'''

ICE_RINGS = '''
!* used by CORRECT to exclude ice-reflections
!EXCLUDE_RESOLUTION_RANGE= 3.93 3.87 !ice-ring at 3.897 Angstrom
!EXCLUDE_RESOLUTION_RANGE= 3.70 3.64 !ice-ring at 3.669 Angstrom
!EXCLUDE_RESOLUTION_RANGE= 3.47 3.41 !ice-ring at 3.441 Angstrom
!EXCLUDE_RESOLUTION_RANGE= 2.70 2.64 !ice-ring at 2.671 Angstrom
!EXCLUDE_RESOLUTION_RANGE= 2.28 2.22 !ice-ring at 2.249 Angstrom
!EXCLUDE_RESOLUTION_RANGE= 2.102 2.042 !ice-ring at 2.072 Angstrom - strong
!EXCLUDE_RESOLUTION_RANGE= 1.978 1.918 !ice-ring at 1.948 Angstrom - weak
!EXCLUDE_RESOLUTION_RANGE= 1.948 1.888 !ice-ring at 1.918 Angstrom - strong
!EXCLUDE_RESOLUTION_RANGE= 1.913 1.853 !ice-ring at 1.883 Angstrom - weak
!EXCLUDE_RESOLUTION_RANGE= 1.751 1.691 !ice-ring at 1.721 Angstrom - weak
'''

MASK_EIGER2_CDTE_4M = """
!EXCLUSION OF VERTICAL DEAD AREAS OF THE EIGER2 4M DETECTOR
UNTRUSTED_RECTANGLE= 1028 1041      0 2163
!EXCLUSION OF HORIZONTAL DEAD AREAS OF THE EIGER 4M DETECTOR
UNTRUSTED_RECTANGLE=    0 2069    512  551
UNTRUSTED_RECTANGLE=    0 2069   1062 1101
UNTRUSTED_RECTANGLE=    0 2069   1612 1651
"""

XDS_TEMPLATE = '''
!==================== XDS.INP GENERATED FOR GMCA =============================
DETECTOR={detector}         MINIMUM_VALID_PIXEL_VALUE=0  OVERLOAD={overload}
SENSOR_THICKNESS={sensor_thickness}        ! SILICON=-1.0
!GAIN=1.0
NX={nx} NY={ny} QX={qx}  QY={qy}
DIRECTION_OF_DETECTOR_X-AXIS= 1.0 0.0 0.0
DIRECTION_OF_DETECTOR_Y-AXIS= {direction_of_detector_y_axis}
TRUSTED_REGION=0. 1.4142
!AIR=0.001
!MINIMUM_FRACTION_OF_BACKGROUND_REGION=0.01

!====================== JOB CONTROL PARAMETERS ===============================
JOB= ALL ! XYCORR INIT COLSPOT IDXREF DEFPIX XPLAN INTEGRATE CORRECT
!MAXIMUM_NUMBER_OF_JOBS=4  !Speeds-up COLSPOT & INTEGRATE on a Linux-cluster
!MAXIMUM_NUMBER_OF_PROCESSORS=8 ! <32; ignored by single cpu version of xds
!SECONDS=0   !Maximum number of seconds to wait until data image must appear
!TEST=1     !Test flag. 1,2 additional diagnostics and images

!====================== GEOMETRICAL PARAMETERS ===============================
ORGX={orgx}  ORGY={orgy}        ! Detector origin (pixels).
DETECTOR_DISTANCE= {distance}   !(mm)
ROTATION_AXIS= 1.0 0.0 0.0
!* degrees (>0) Optimal choice is 0.5*mosaicity (REFLECTING_RANGE_E.S.D.= mosaicity)
OSCILLATION_RANGE={osc_range}
X-RAY_WAVELENGTH= {wavelength}  ! Angstroem
INCIDENT_BEAM_DIRECTION=0.0 0.0 1.0
FRACTION_OF_POLARIZATION=0.99   ! default=0.5 for unpolarized beam
POLARIZATION_PLANE_NORMAL= 0.0 1.0 0.0

!======================= CRYSTAL PARAMETERS =================================
SPACE_GROUP_NUMBER=0   !* 0 for unknown crystals; cell constants are ignored.
!UNIT_CELL_CONSTANTS= 180.7 180.7 180.7 90 90.0 90.0
!* You may specify here the x,y,z components for the unit cell vectors if
!* known from a previous run using the same crystal in the same orientation
!UNIT_CELL_A-AXIS=
!UNIT_CELL_B-AXIS=
!UNIT_CELL_C-AXIS=

FRIEDEL'S_LAW=FALSE

!* Optional reindexing transformation to apply on reflection indices
!REIDX=   0  0 -1  0  0 -1  0  0 -1  0  0  0
!REFERENCE_DATA_SET= REFERENCE.HKL   ! Name of a reference data set (optional)
!FIT_B-FACTOR_TO_REFERENCE_DATA_SET=TRUE ! default is FALSE

!==================== SELECTION OF DATA IMAGES ==============================
NAME_TEMPLATE_OF_DATA_FRAMES= {template}
DATA_RANGE={data_range}       ! Numbers of first and last data image collected
BACKGROUND_RANGE={bg_range}   ! Numbers of first and last data image for background
{spot_ranges}
!LIB= fill in path and file name of Dectris-provided library
!EXCLUDE_DATA_RANGE=  1  1

!==================== DATA COLLECTION STRATEGY (XPLAN) ======================
!* *Warning*: If you processed your data for a crystal with unknown cell constants and
!* space group symmetry, XPLAN will report the results for space group P1.
STARTING_ANGLE=  {start_angle}      STARTING_FRAME= {start_frame}
!* used to define the angular origin about the rotation axis
!* Default:  STARTING_ANGLE=  0 at STARTING_FRAME=first data image
!RESOLUTION_SHELLS= {resolution_shells}
STARTING_ANGLES_OF_SPINDLE_ROTATION= 0 180 10
TOTAL_SPINDLE_ROTATION_RANGES={total_spindle_rot_ranges} !5 25 5 multiple-crystal; 10 120 10 single-xtal

!====================== INDEXING PARAMETERS =================================
SEPMIN=4 CLUSTER_RADIUS=2
!* used by "IDXREF" to add an index offset,
!* Never forget to check this, since the default 0 0 0 is almost always correct!
!INDEX_ORIGIN= 0 0 0
!Additional parameters for fine tuning that rarely need to be changed
!INDEX_ERROR=0.05 INDEX_MAGNITUDE=8 INDEX_QUALITY=0.8
!MAXIMUM_ERROR_OF_SPOT_POSITION=3.0
!MAXIMUM_ERROR_OF_SPINDLE_POSITION=2.0
!MINIMUM_FRACTION_OF_INDEXED_SPOTS=0.5

!============== DECISION CONSTANTS FOR FINDING CRYSTAL SYMMETRY =============
!* Maximum relative error in cell axes tolerated,
!* decision constants for detection of lattice symmetry (IDXREF, CORRECT)
!MAX_CELL_AXIS_ERROR=0.03
!MAX_CELL_ANGLE_ERROR=2.0 ! Maximum cell angle error tolerated
!* Decision constants for detection of space group symmetry (CORRECT).
!* Resolution range for accepting reflections for space group determination in the CORRECT step.
!* It should cover a sufficient number of strong reflections.
!TEST_RESOLUTION_RANGE=8.0 4.5
!MIN_RFL_Rmeas= 50 ! Minimum #reflections needed for calculation of Rmeas
!MAX_FAC_Rmeas=2.0 ! Sets an upper limit for acceptable Rmeas

!================= PARAMETERS CONTROLLING REFINEMENTS =======================
REFINE(IDXREF)= CELL BEAM ORIENTATION AXIS !POSITION
REFINE(INTEGRATE)= BEAM ORIENTATION POSITION ! AXIS CELL
REFINE(CORRECT)= POSITION BEAM ORIENTATION CELL AXIS

!================== CRITERIA FOR ACCEPTING REFLECTIONS ======================
!* Used by DEFPIX for excluding shaded parts of the detector.
VALUE_RANGE_FOR_TRUSTED_DETECTOR_PIXELS= 6000 30000
!* Angstrom; used by DEFPIX,INTEGRATE,CORRECT
INCLUDE_RESOLUTION_RANGE=50.0 {high_res}
!* Defines width of 'blind region' (XPLAN,INTEGRATE,CORRECT)
!MINIMUM_ZETA=0.05
!* This controls the number of rejected MISFITS in CORRECT;
!* a larger value leads to fewer rejections.
!WFAC1=1.0
!* Automatic rejection of very strong reflections
!REJECT_ALIEN=20.0

!============== INTEGRATION AND PEAK PROFILE PARAMETERS =====================
!used by: INTEGRATE, 13 for pilatus, 21 for eiger, default 9
NUMBER_OF_PROFILE_GRID_POINTS_ALONG_ALPHA/BETA={n_profile_ab}
NUMBER_OF_PROFILE_GRID_POINTS_ALONG_GAMMA= {n_profile_g}
!* arctan(spot diameter/DETECTOR_DISTANCE)
!* Specification of the peak profile parameters below overrides the automatic
!* determination from the images, suggested values are listed near the end of INTEGRATE.LP
!BEAM_DIVERGENCE=   0.80
!BEAM_DIVERGENCE_E.S.D.=   0.080 !half-width (Sigma) of BEAM_DIVERGENCE
!REFLECTING_RANGE=  0.780 !for crossing the Ewald sphere on shortest route
!REFLECTING_RANGE_E.S.D.=  0.113 !half-width (mosaicity) of REFLECTING_RANGE
!DELPHI= 6.0 ! controls the number of reference profiles and scaling factors
!CUT=2.0     ! defines the integration region for profile fitting
!MINPK=75.0  ! minimum required percentage of observed reflection intensity

!======= PARAMETERS CONTROLLING CORRECTION FACTORS (used by: CORRECT) =======
!MINIMUM_I/SIGMA=3.0 !minimum intensity/sigma required for scaling reflections
!NBATCH=-1  !controls the number of correction factors along image numbers
!REFLECTIONS/CORRECTION_FACTOR=50   !minimum #reflections/correction needed
!PATCH_SHUTTER_PROBLEM=TRUE         !FALSE is default
!STRICT_ABSORPTION_CORRECTION=TRUE  !FALSE is default
!CORRECTIONS= DECAY MODULATION ABSORPTION

!=========== PARAMETERS DEFINING BACKGROUND AND PEAK PIXELS =================
!* used by: COLSPOT This allows to suppress spurious isolated pixels
!* from entering the spot list generated by "COLSPOT".
MINIMUM_NUMBER_OF_PIXELS_IN_A_SPOT=3
!* used by: COLSPOT A 'strong' pixel to be included in a spot must exceed the
!* background by more than the given multiple of standard deviations.
STRONG_PIXEL=4.0
!MAXIMUM_NUMBER_OF_STRONG_PIXELS=1500000     !used by: COLSPOT
!SPOT_MAXIMUM-CENTROID=3.0                   !used by: COLSPOT
!* Define a rectangle of size (2*NBX+1)*(2*NBY+1)
!* The variation of counts within the rectangle centered at each image pixel is
!* used for distinguishing between background and spot pixels.
!NBX=3  NBY=3
!* used by: COLSPOT,INTEGRATE An image pixel does not belong to the background
!* region if the local pixel variation exceeds the expected variation
!* by the given number of standard deviations.
!BACKGROUND_PIXEL=6.0
!* used by: INTEGRATE A pixel above the threshold contributes to the spot centroid
!SIGNAL_PIXEL=3.0
!DATA_RANGE_FIXED_SCALE_FACTOR= 1 60 1.0 ! used by : INIT,INTEGRATE

!=========== MASKING OUT DEAD REGIONS OF DETECTOR AND ICERINGS ==============
{detector_mask}
{ice_rings}
{additional}
'''
