# -*- coding: utf-8 -*-
# /mnt/software/anaconda3/bin/conda install -c conda-forge watchdog
# /mnt/software/anaconda3/bin/pip install concurrent-log-handler
# 09/17/2018 /mnt/software/anaconda3/bin/pip install concurrent-log-handler --upgrade
# 1/11/2019 conda install -c anaconda drmaa 
# 1/11/2019 fast_ep uses drmaa python plugin, 
#     on bl[12]ws12 install it into ccp4 python :/mnt/software/px/CCP4-7.0.0/ccp4-7.0/libexec/pip install drmaa

from setuptools import setup, find_packages

setup(
    name='quickProcess',
    version="1.0",
    packages=find_packages(),
    include_package_data=False,
    install_requires=['peewee','pymysql', 'tabulate', 'concurrent-log-handler', 'watchdog', 'drmaa'],
    author='qxu@anl.org',
    author_email='qxu@anl.gov',
    entry_points = {
        'console_scripts': ['quickProcess=quickProcess.process.__main__:main',
                           'strategy=quickProcess.strategy.__main__:main',
                           'collect_simulator=quickProcess.simulators.collect_simulator.collect_sim:main',
                           'screen_simulator=quickProcess.simulators.screen_simulator.screen_sim:main',
                           'processall_simulator=quickProcess.simulators.processall_simulator.processall:main',
			   ]
    }
)
